function varargout = GOA(varargin)
% GOA M-file for GOA.fig
%      GOA, by itself, creates a new GOA or raises the existing
%      singleton*.
%
%      H = GOA returns the handle to a new GOA or the handle to
%      the existing singleton*.
%
%      GOA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GOA.M with the given input arguments.
%
%      GOA('Property','Value',...) creates a new GOA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GOA_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property
%      application
%      stop.  All inputs are passed to GOA_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GOA

% Last Modified by GUIDE v2.5 19-Sep-2010 19:05:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GOA_OpeningFcn, ...
                   'gui_OutputFcn',  @GOA_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GOA is made visible.
function GOA_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GOA (see VARARGIN)

% Choose default command line output for GOA
handles.output = hObject;

if ~isfield(handles,'initialized')

    set(handles.mode1_togglebutton,'Value',0);
    set(handles.mode1_panel,'Visible','off');
    set(handles.mode2_togglebutton,'Value',1);
    set(handles.mode2_panel,'Visible','on');
    
    set(handles.noniso_checkbox,'Visible','off');
    set(handles.clnoniso_text,'Visible','off');
    set(handles.clengthx_edit,'Visible','off');
    set(handles.clengthy_edit,'Visible','off');
    set(handles.cliso_text,'Visible','on');
    set(handles.clength_edit,'Visible','on');
    set(handles.x_text,'Visible','off');
    set(handles.y_text,'Visible','off');
    
    set(handles.singleresults_panel,'Visible','off');
    set(handles.totalresults_panel,'Visible','off');
    set(handles.output_panel,'Visible','on');
    
    handles.version = 1.01;
    handles.versionlimit = 1.01;
    handles.versionlimit_RSG = 1.01; % earliest version of RSG supported
    
    handles.workdir = fileparts(mfilename);
    
    handles.initialized = 1;
    
    % Update handles structure
    guidata(hObject, handles);

end

% UIWAIT makes GOA wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GOA_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in exit_pushbutton.
function exit_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to exit_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close

% --- Executes on button press in saveresults_pushbutton.
function saveresults_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to saveresults_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isfield(handles,'Results')
    return
end

pathName = handles.workdir;

dateandtime = datestr(now,'yyyy-mm-dd HH:MM:SS'); 

%% Export to mat-file
fileName = cat(2,datestr(now,'yyyymmdd_HHMMSS'),'.mat');
GOA.Date = dateandtime;
GOA.Version = handles.version;
if handles.Results.Mode == 1 % Mode 1
    mode = 'Saved';
    
    % input data
    GOA.Input.Mode = mode;
    GOA.Input.Dimension = handles.Results.Dimension;
    
    GOA.Input.Surface.NumberOf =  size(cell2mat(get(handles.surf_listbox,'String')),1);
    surflist =  cell2mat(get(handles.surf_listbox,'String'));
    GOA.Input.Surface.List = surflist(:,1:end-4);
    
    GOA.Input.Light.NumberofRays = handles.Results.rays;
    GOA.Input.Light.BeamDistribution = handles.Results.beamdist;
    GOA.Input.Light.BeamRadius = handles.Results.beamradius;
    GOA.Input.Light.AOI.Theta = handles.Results.Thetas;
    
    GOA.Input.Material.Incident.n = handles.Results.n1;
    GOA.Input.Material.Incident.k = handles.Results.k1;
    GOA.Input.Material.Scattering.n = handles.Results.n2;
    GOA.Input.Material.Scattering.k = handles.Results.k2;
    
    % output data
    GOA.Output.DHR.data = handles.Results.Totals.DHR;
    GOA.Output.scatpts.data = handles.Results.Totals.scatpts;
    GOA.Output.shadowing.data = handles.Results.Totals.shadowing;
    GOA.Output.warnings.data = handles.Results.Totals.warnings;
    GOA.Output.brdf.data = handles.Results.Totals.brdf;
    GOA.Output.errors.data = handles.Results.Totals.errors;
    
    if handles.Results.Dimension == 1 %1D surfaces
        GOA.Output.DHR.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.scatpts.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.shadowing.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.warnings.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.errors.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.brdf.dimheader = {'slope' 'theta(incident)' 'scattering order' 'theta(scattering)'};
    else
        GOA.Input.Light.AOI.Phi = handles.Results.Phis;
        GOA.Output.DHR.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.scatpts.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.shadowing.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.warnings.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.errors.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.brdf.dimheader = {'slope' 'theta(incident)' 'phi(incident)' 'scattering order' 'theta(scattering)' 'phi(scattering)'};
    end
    
    % save results for each surface
    for n = 1:GOA.Input.Surface.NumberOf
        eval(cat(2,'GOA.Output.Surface',num2str(n), '= handles.Results.Surface',num2str(n),';'));
        eval(cat(2,'GOA.Output.Surface',num2str(n),'.Name = GOA.Input.Surface.List(n,:);'));
    end
    
else % Monte Carlo mode
    mode = 'MonteCarlo';
    
    % input data
    GOA.Input.Mode = mode;
    GOA.Input.Dimension = handles.Results.Dimension;
    GOA.Input.NumberofRealisations = handles.Results.Realisations;
    
    GOA.Input.Surface.Surfpts = handles.Results.surfpts;
    GOA.Input.Surface.SurfLength = handles.Results.surflength;
    GOA.Input.Surface.HDF = handles.Results.hdf;
    GOA.Input.Surface.ACF = handles.Results.acf;
    GOA.Input.Surface.RmsHeights = handles.Results.rmsheight;
    
    GOA.Input.Light.NumberofRays = handles.Results.rays;
    GOA.Input.Light.BeamDistribution = handles.Results.beamdist;
    GOA.Input.Light.BeamRadius = handles.Results.beamradius;
    GOA.Input.Light.AOI.Theta = handles.Results.Thetas;
    
    GOA.Input.Material.Incident.n = handles.Results.n1;
    GOA.Input.Material.Incident.k = handles.Results.k1;
    GOA.Input.Material.Scattering.n = handles.Results.n2;
    GOA.Input.Material.Scattering.k = handles.Results.k2;
    
    % output data
    GOA.Output.DHR.data = handles.Results.Totals.DHR;
    GOA.Output.scatpts.data = handles.Results.Totals.scatpts;
    GOA.Output.shadowing.data = handles.Results.Totals.shadowing;
    GOA.Output.warnings.data = handles.Results.Totals.warnings;
    GOA.Output.brdf.data = handles.Results.Totals.brdf;
    GOA.Output.errors.data = handles.Results.Totals.errors;
    
    if handles.Results.Dimension == 1 %1D surfaces
        GOA.Input.Surface.CorrelationLengths = handles.Results.cl;
        GOA.Output.DHR.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.scatpts.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.shadowing.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.warnings.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.errors.dimheader = {'slope' 'theta(incident)'};
        GOA.Output.brdf.dimheader = {'slope' 'theta(incident)' 'scattering order' 'theta(scattering)'};
    else %2D surfaces
        GOA.Input.Surface.CorrelationLengths.x = handles.Results.clx;
        GOA.Input.Surface.CorrelationLengths.y = handles.Results.cly;
        GOA.Input.Light.AOI.Phi = handles.Results.Phis;
        GOA.Output.DHR.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.scatpts.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.shadowing.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.warnings.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.errors.dimheader = {'slope' 'theta(incident)' 'phi(incident)'};
        GOA.Output.brdf.dimheader = {'slope' 'theta(incident)' 'phi(incident)' 'scattering order' 'theta(scattering)' 'phi(scattering)'};
    end
end

save(fullfile(pathName,fileName),'-struct','GOA');

%% Export to textfile
% 
% %% Inputs file
% fileName = cat(2,datestr(now,'yyyymmdd_HHMMSS'),'_input.txt');
% fid = fopen(fullfile(pathName,fileName), 'w');
% 
% % Write header with inputs
% fprintf(fid, '%s\n\n','%%% Input File %%%');
% fprintf(fid, '%s ','Date');
% fprintf(fid, '%s\n',dateandtime(1:10));
% fprintf(fid, '%s ','Time');
% fprintf(fid, '%s\n',dateandtime(12:end));
% fprintf(fid, '%s ','Version');
% fprintf(fid, '%3.2f\n',handles.version);
% fprintf(fid, '\n');
% 
% if handles.Results.Mode == 1 % Mode 1
% 
% else % Monte Carlo mode
%     
%     if handles.Results.Dimension == 1 %1D surfaces
%         
%         fprintf(fid, '%s ', 'Mode');
%         fprintf(fid, '%s\n', mode);
%         fprintf(fid, '%s ', 'Dimensions');
%         fprintf(fid, '%i\n', handles.Results.Dimension);
%         fprintf(fid, '%s ', 'Realisations');
%         fprintf(fid, '%i\n', handles.Results.Realisations);
%         fprintf(fid, '%s ', 'Surfpts');
%         fprintf(fid, '%i\n', handles.Results.surfpts);
%         fprintf(fid, '%s ', 'SurfLength');
%         fprintf(fid, '%.4f\n', handles.Results.surflength);
%         fprintf(fid, '%s ', 'HDF');
%         fprintf(fid, '%s\n', handles.Results.hdf);
%         fprintf(fid, '%s ', 'ACF');
%         fprintf(fid, '%s\n', handles.Results.acf);
%         fprintf(fid, '%s ', 'RMSHeights');
%         fprintf(fid, '%.4f ', handles.Results.rmsheight);
%         fprintf(fid, '\n%s ', 'CorrelationLengths');
%         fprintf(fid, '%.4f ', handles.Results.cl);
%         fprintf(fid, '\n');
%         
%         fprintf(fid, '%s ','Rays');
%         fprintf(fid, '%i\n', handles.Results.rays);
%         fprintf(fid, '%s ','BeamDistribution');
%         fprintf(fid, '%s\n', handles.Results.beamdist);
%         fprintf(fid, '%s ','BeamRadius');
%         fprintf(fid, '%.4f\n', handles.Results.beamradius);
%         fprintf(fid, '%s ', 'Theta(AOI)');
%         fprintf(fid, '%.2f ', handles.Results.Thetas);
%         fprintf(fid, '\n');
%         
%         
%         fprintf(fid, '%s ', 'n1');
%         fprintf(fid, '%.3f\n', handles.Results.n1);
%         fprintf(fid, '%s ', 'k1');
%         fprintf(fid, '%.3f\n', handles.Results.k1);
%         fprintf(fid, '%s ', 'n2');
%         fprintf(fid, '%.3f\n', handles.Results.n2);
%         fprintf(fid, '%s ', 'k2');
%         fprintf(fid, '%.3f\n', handles.Results.k2);
%         fprintf(fid, '\n');
%         
%     else %2D surfaces
%         
%         fprintf(fid, '%s ', 'Mode');
%         fprintf(fid, '%s\n', mode);
%         fprintf(fid, '%s ', 'Dimensions');
%         fprintf(fid, '%i\n', handles.Results.Dimension);
%         fprintf(fid, '%s ', 'Realisations');
%         fprintf(fid, '%i\n', handles.Results.Realisations);
%         fprintf(fid, '%s ', 'Surfpts');
%         fprintf(fid, '%i\n', handles.Results.surfpts);
%         fprintf(fid, '%s ', 'SurfLength');
%         fprintf(fid, '%.4f\n', handles.Results.surflength);
%         fprintf(fid, '%s ', 'HDF');
%         fprintf(fid, '%s\n', handles.Results.hdf);
%         fprintf(fid, '%s ', 'ACF');
%         fprintf(fid, '%s\n', handles.Results.acf);
%         fprintf(fid, '%s ', 'RMSHeights');
%         fprintf(fid, '%.4f ', handles.Results.rmsheight);
%         fprintf(fid, '\n%s ', 'CorrelationLengths(x)');
%         fprintf(fid, '%.4f ', handles.Results.clx);
%         fprintf(fid, '\n%s ', 'CorrelationLengths(y)');
%         fprintf(fid, '%.4f ', handles.Results.cly);
%         fprintf(fid, '\n');
%         
%         fprintf(fid, '%s ','Rays');
%         fprintf(fid, '%i\n', handles.Results.rays);
%         fprintf(fid, '%s ','BeamDistribution');
%         fprintf(fid, '%s\n', handles.Results.beamdist);
%         fprintf(fid, '%s ','BeamRadius');
%         fprintf(fid, '%.4f\n', handles.Results.beamradius);
%         fprintf(fid, '%s ', 'Theta(AOI)');
%         fprintf(fid, '%.2f ', handles.Results.Thetas');
%         fprintf(fid, '\n%s ', 'Phi(AOI)');
%         fprintf(fid, '%.2f ', handles.Results.Phis');
%         fprintf(fid, '\n');
% 
%         
%         fprintf(fid, '%s ', 'n1');
%         fprintf(fid, '%.3f\n', handles.Results.n1);
%         fprintf(fid, '%s ', 'k1');
%         fprintf(fid, '%.3f\n', handles.Results.k1);
%         fprintf(fid, '%s ', 'n2');
%         fprintf(fid, '%.3f\n', handles.Results.n2);
%         fprintf(fid, '%s ', 'k2');
%         fprintf(fid, '%.3f', handles.Results.k2);
%        
%     end
% end
% 
% fclose(fid);
% 
% %% Results file
% 
% fileName = cat(2,datestr(now,'yyyymmdd_HHMMSS'),'_results.txt');
% 
% fid = fopen(fullfile(pathName,fileName), 'w');
% 
% % Write header with inputs
% fprintf(fid, '%s\n\n','%%% Results File %%%');
% fprintf(fid, '%s ','Date');
% fprintf(fid, '%s\n',dateandtime(1:10));
% fprintf(fid, '%s ','Time');
% fprintf(fid, '%s\n',dateandtime(12:end));
% fprintf(fid, '%s ','Version');
% fprintf(fid, '%3.2f\n',handles.version);
% fprintf(fid, '\n');
% 
% if handles.Results.Mode == 1 % Mode 1
%     
% else % Monte Carlo mode
% 
%     if handles.Results.Dimension == 1 %1D surfaces
% 
%         fprintf(fid, '%s\n', '%% vs. slope');
%         fprintf(fid, '%s\n', 'Slopes');
%         fprintf(fid, '%.3f ', handles.Results.Slopes);
%         fprintf(fid, '\n');
%         for n = 1:length(handles.Results.Thetas)
%             fprintf(fid, '\n%s ', '% Theta(AOI)');
%             fprintf(fid, '%.2f', handles.Results.Thetas(n));
%             fprintf(fid, '\n%s\n', 'DHR');
%             fprintf(fid, '%.4f ', handles.Results.Totals.DHR(:,n));
%             fprintf(fid, '\n%s\n', 'ScatteringPts');
%             fprintf(fid, '%.2f ', handles.Results.Totals.scatpts(:,n));
%             fprintf(fid, '\n%s\n', 'Shadowing');
%             fprintf(fid, '%.3f ', handles.Results.Totals.shadowing(:,n));
%             fprintf(fid, '\n%s\n', 'Warnings');
%             fprintf(fid, '%.2f ', handles.Results.Totals.warnings(:,n));
%             fprintf(fid, '\n%s\n', 'Errors');
%             fprintf(fid, '%.2f ', handles.Results.Totals.errors(:,n));
%             fprintf(fid, '\n');
%         end
%         
%         fprintf(fid, '\n\n%s\n', '%% vs. theta(AOI)');
%         fprintf(fid, '%s\n', 'Theta(AOI)');
%         fprintf(fid, '%.2f ', handles.Results.Thetas);
%         fprintf(fid, '\n');
%         for n = 1:length(handles.Results.Slopes)
%             fprintf(fid, '\n%s ', '% Slope');
%             fprintf(fid, '%.3f', handles.Results.Slopes(n));
%             fprintf(fid, '\n%s\n', 'DHR');
%             fprintf(fid, '%.4f ', handles.Results.Totals.DHR(n,:));
%             fprintf(fid, '\n%s\n', 'ScatteringPts');
%             fprintf(fid, '%.2f ', handles.Results.Totals.scatpts(n,:));
%             fprintf(fid, '\n%s\n', 'Shadowing');
%             fprintf(fid, '%.3f ', handles.Results.Totals.shadowing(n,:));
%             fprintf(fid, '\n%s\n', 'Warnings');
%             fprintf(fid, '%.3f ', handles.Results.Totals.warnings(n,:));
%             fprintf(fid, '\n%s\n', 'Errors');
%             fprintf(fid, '%i ', handles.Results.Totals.errors(n,:));
%             fprintf(fid, '\n');
%         end
%     
%     else %2D surfaces
%         
%         fprintf(fid, '%s\n', '%% vs. slope');
%         fprintf(fid, '%s\n', 'Slopes');
%         fprintf(fid, '%.3f ', handles.Results.Slopes);
%         fprintf(fid, '\n');
%         for n = 1:length(handles.Results.Thetas)
%             for m = 1:length(handles.Results.Phis)
%                 fprintf(fid, '\n%s ', '% Theta(AOI)');
%                 fprintf(fid, '%.2f ', handles.Results.Thetas(n));
%                 fprintf(fid, '%s ', 'Phi(AOI)');
%                 fprintf(fid, '%.2f ', handles.Results.Phis(m));
%                 fprintf(fid, '\n%s\n', 'DHR');
%                 fprintf(fid, '%.4f ', handles.Results.Totals.DHR(:,n,m));
%                 fprintf(fid, '\n%s\n', 'ScatteringPts');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.scatpts(:,n,m));
%                 fprintf(fid, '\n%s\n', 'Shadowing');
%                 fprintf(fid, '%.3f ', handles.Results.Totals.shadowing(:,n,m));
%                 fprintf(fid, '\n%s\n', 'Warnings');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.warnings(:,n,m));
%                 fprintf(fid, '\n%s\n', 'Errors');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.errors(:,n,m));
%                 fprintf(fid, '\n');
%             end
%         end
%         
%         fprintf(fid, '\n\n%s\n', '%% vs. theta(AOI)');
%         fprintf(fid, '%s\n', 'Theta(AOI)');
%         fprintf(fid, '%.2f ', handles.Results.Thetas);
%         fprintf(fid, '\n');
%         for n = 1:length(handles.Results.Slopes)
%             for m = 1:length(handles.Results.Phis)
%                 fprintf(fid, '\n%s ', '% Slope');
%                 fprintf(fid, '%.3f ', handles.Results.Slopes(n));
%                 fprintf(fid, '%s ', 'Phi(AOI)');
%                 fprintf(fid, '%.2f ', handles.Results.Phis(m));
%                 fprintf(fid, '\n%s\n', 'DHR');
%                 fprintf(fid, '%.4f ', handles.Results.Totals.DHR(n,:,m));
%                 fprintf(fid, '\n%s\n', 'ScatteringPts');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.scatpts(n,:,m));
%                 fprintf(fid, '\n%s\n', 'Shadowing');
%                 fprintf(fid, '%.3f ', handles.Results.Totals.shadowing(n,:,m));
%                 fprintf(fid, '\n%s\n', 'Warnings');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.warnings(n,:,m));
%                 fprintf(fid, '\n%s\n', 'Errors');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.errors(n,:,m));
%                 fprintf(fid, '\n');
%             end
%         end
%         
%         fprintf(fid, '\n\n%s\n', '%% vs. phi(AOI)');
%         fprintf(fid, '%s\n', 'Phi(AOI)');
%         fprintf(fid, '%.2f ', handles.Results.Phis);
%         fprintf(fid, '\n');
%         for n = 1:length(handles.Results.Slopes)
%             for m = 1:length(handles.Results.Thetas)
%                 fprintf(fid, '\n%s ', '% Slope');
%                 fprintf(fid, '%.3f ', handles.Results.Slopes(n));
%                 fprintf(fid, '%s ', 'Theta(AOI)');
%                 fprintf(fid, '%.2f ', handles.Results.Thetas(m));
%                 fprintf(fid, '\n%s\n', 'DHR');
%                 fprintf(fid, '%.4f ', handles.Results.Totals.DHR(n,m,:));
%                 fprintf(fid, '\n%s\n', 'ScatteringPts');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.scatpts(n,m,:));
%                 fprintf(fid, '\n%s\n', 'Shadowing');
%                 fprintf(fid, '%.3f ', handles.Results.Totals.shadowing(n,m,:));
%                 fprintf(fid, '\n%s\n', 'Warnings');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.warnings(n,m,:));
%                 fprintf(fid, '\n%s\n', 'Errors');
%                 fprintf(fid, '%.2f ', handles.Results.Totals.errors(n,m,:));
%                 fprintf(fid, '\n');
%             end
%         end
%         
%     end
% end
% 
% fprintf(fid, '\n%s ', '%%%%%%%%%%%%%%%%%%%%%%%%%%');
% fprintf(fid, '\n%s ', 'RunTime[s]');
% fprintf(fid, '%.2f\n', sum(handles.Results.Totals.elapsedtime));
% fprintf(fid, '%s ', 'Errors');
% fprintf(fid, '%i\n', sum(sum(sum(handles.Results.Totals.errors))));
% fprintf(fid, '\n');
% 
% fclose(fid);
% 
% %% BRDF file (to be implemented)
% 
% fileName = cat(2,datestr(now,'yyyymmdd_HHMMSS'),'_BRDF.txt');
% 
% fid = fopen(fullfile(pathName,fileName), 'w');
% 
% % Write header with inputs
% fprintf(fid, '%s\n\n','%%% BRDF File %%%');
% fprintf(fid, '%s ','Date');
% fprintf(fid, '%s\n',dateandtime(1:10));
% fprintf(fid, '%s ','Time');
% fprintf(fid, '%s\n',dateandtime(12:end));
% fprintf(fid, '%s ','Version');
% fprintf(fid, '%3.2f\n',handles.version);
% fprintf(fid, '\n');
% 
% if handles.Results.Mode == 1 % Mode 1
%     
% else % Monte Carlo mode
%     if handles.Results.Dimension == 1 %1D surfaces
%         fprintf(fid, '%s\n','%% BRDF (total)');
%         fprintf(fid, '%s\n','Scattering angles (theta): -90:90');
%         for n = 1:length(handles.Results.Slopes)
%             for m = 1:length(handles.Results.Thetas)
%                 fseek(fid,0,'eof');
%                 fprintf(fid, '\n');
%                 fprintf(fid, '%s\n', 'Slope Theta(AOI)');
%                 fprintf(fid, '%.3f %.2f\n', handles.Results.Slopes(n), handles.Results.Thetas(m));
%                 fprintf(fid, '\n');
%                 fprintf(fid, '%.2f ', -90:90);
%                 fprintf(fid, '\n');
%                 brdfdata = squeeze(sum(handles.Results.Totals.brdf(n,m,:,:),3))';
%                 dlmwrite(fullfile(pathName,fileName),brdfdata,'-append','delimiter',' ','precision','%.2f');
%             end
%         end
%     
%     else
%         fprintf(fid, '%s\n','%% BRDF (total)');
%         fprintf(fid, '%s\n','Scattering angles (theta): -90:90');
%         fprintf(fid, '%s\n','Scattering angles (phi): 0:90');
%         for n = 1:length(handles.Results.Slopes)
%             for m = 1:length(handles.Results.Thetas)
%                 for l = 1:length(handles.Results.Phis)
%                     fseek(fid,0,'eof');
%                     fprintf(fid, '\n');
%                     fprintf(fid, '%s\n', 'Slope Theta(AOI) Phi(AOI)');
%                     fprintf(fid, '%.3f %.2f %.2f\n', handles.Results.Slopes(n), handles.Results.Thetas(m), handles.Results.Phis(l));
%                     fprintf(fid, '\n');
%                     fprintf(fid, '* ');
%                     fprintf(fid, '%.2f ', -90:90);
%                     brdfdata = [[0:90]' squeeze(sum(handles.Results.Totals.brdf(n,m,l,:,:,:),4))];
%                     dlmwrite(fullfile(pathName,fileName),brdfdata,'-append','delimiter',' ','precision','%.2f');
%                 end
%             end
%         end
%     end
% end
% 
% fclose(fid);

% --- Executes on button press in run_pushbutton.
function run_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to run_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(handles.mode2_togglebutton,'Value') % Monte Carlo mode
    if checkinput(handles)
        set(handles.singleresults_panel,'Visible','off');
        set(handles.totalresults_panel,'Visible','off');
        
        set(handles.results_listbox,'String','');
        contents = cellstr('');
        set(handles.results_listbox, 'Value', 0);
        
        % calculate number of slopes
        rmsheight = sort(str2num(get(handles.rmsheight_edit,'String')));
        if get(handles.twod_togglebutton,'Value') && get(handles.noniso_checkbox,'Value')
            clx = sort(str2num(get(handles.clengthx_edit,'String')));
            cly = sort(str2num(get(handles.clengthy_edit,'String')));
            if length(clx) >= length(cly)
                slopes = rmsheight./clx;
            else
                slopes = rmsheight./cly;
            end
        else
            cl = sort(str2num(get(handles.clength_edit,'String')));
            slopes = rmsheight./cl;
        end 
        
        % calculate number of angles
        theta = sort(str2num(get(handles.theta_edit,'String')));
        phi = sort(str2num(get(handles.phi_edit,'String')));
        if length(theta) > 1
            numberofthetas = length(theta);
        else numberofthetas = 1;
        end
        if length(phi) > 1 && get(handles.twod_togglebutton,'Value')
            numberofphis = length(phi);
        else numberofphis = 1;
        end
                
        numberofrealisations = length(slopes)*numberofthetas*numberofphis*str2double(get(handles.realisations_edit,'String'));

        if isfield(handles,'Results')
            handles = rmfield(handles,'Results'); % reset results
        end
        
        % intialize results
        
        handles.Results.Mode = 2;
        if get(handles.oned_togglebutton,'Value')
            handles.Results.Dimension = 1;
            handles.Results.Slopes = slopes;
            handles.Results.Thetas = theta;
            handles.Results.Realisations = str2double(get(handles.realisations_edit,'String'));
            handles.Results.Totals.DHR = zeros(length(slopes),numberofthetas);
            handles.Results.Totals.brdf = zeros(length(slopes),numberofthetas,3,181);
            handles.Results.Totals.scatpts = zeros(length(slopes),numberofthetas);
            handles.Results.Totals.shadowing = zeros(length(slopes),numberofthetas);
            handles.Results.Totals.warnings = zeros(length(slopes),numberofthetas);
            handles.Results.Totals.errors = zeros(length(slopes),numberofthetas);
        else handles.Results.Dimension = 2;
            handles.Results.Slopes = slopes;
            handles.Results.Thetas = theta;
            handles.Results.Phis = phi;
            handles.Results.Realisations = str2double(get(handles.realisations_edit,'String'));
            handles.Results.Totals.DHR = zeros(length(slopes),numberofthetas,numberofphis);
            handles.Results.Totals.brdf = zeros(length(slopes),numberofthetas,numberofphis,3,91,360);
            handles.Results.Totals.scatpts = zeros(length(slopes),numberofthetas,numberofphis);
            handles.Results.Totals.shadowing = zeros(length(slopes),numberofthetas,numberofphis);
            handles.Results.Totals.warnings = zeros(length(slopes),numberofthetas,numberofphis);
            handles.Results.Totals.errors = zeros(length(slopes),numberofthetas,numberofphis);
        end
        handles.Results.Totals.elapsedtime = zeros(1,numberofrealisations);
        
        h = waitbar(0,'Initializing...');
        listindex = 1; realisationindex = 1;
        timeleft = 0;
        
        for slopeindex = 1:length(slopes)
            
            contents{listindex} = cat(2,'Slope',num2str(slopes(slopeindex)));
            listindex = listindex + 1;
            
            for thetaindex = 1:numberofthetas
                
                contents{listindex} = cat(2,' Theta',num2str(theta(thetaindex)));
                listindex = listindex + 1;
                
                for phiindex = 1:numberofphis
                    
                    if get(handles.twod_togglebutton,'Value')
                        contents{listindex} = cat(2,'  Phi',num2str(phi(phiindex)));
                        listindex = listindex + 1;
                    end
                    
                    realisation = 1; % reset realisation counting
                    
                    while realisation <= str2double(get(handles.realisations_edit,'String'))

                        if realisationindex == 1
                            msg = cat(2,'Processing surface ',num2str(realisationindex),' of ',num2str(numberofrealisations),'. Appr. \infty [s] left.');
                        else
                            msg = cat(2,'Processing surface ',num2str(realisationindex),' of ',num2str(numberofrealisations),'. Appr. ',num2str(timeleft,'%.0f'),' [s] left.');
                        end
                        waitbar(realisationindex/numberofrealisations,h,msg);
                        
                        tic % start clock for for run-time calculation
                        
                        if get(handles.oned_togglebutton,'Value') % 1D surface
                            
                            %% surface generation
                            % load input parameters
                            surfpts = str2double(get(handles.surfpts_edit,'String'));
                            surflength = str2double(get(handles.surflength_edit,'String'));
                            % check selected surface statistics
                            % acf
                            if get(handles.acf_popupmenu,'Value') == 1 % gaussian
                                if length(rmsheight) > 1 && length(cl) == 1
                                    [f,x] = rsgeng1D(surfpts,surflength,rmsheight(slopeindex),cl);
                                elseif length(rmsheight) > 1 && length(cl) > 1
                                    [f,x] = rsgeng1D(surfpts,surflength,rmsheight(slopeindex),cl(slopeindex));
                                elseif length(rmsheight) == 1 && length(cl) > 1
                                    [f,x] = rsgeng1D(surfpts,surflength,rmsheight,cl(slopeindex));
                                else
                                    [f,x] = rsgeng1D(surfpts,surflength,rmsheight,cl);
                                end
                                handles.Results.acf = 'gauss';
                            elseif get(handles.acf_popupmenu,'Value') == 2 % exponential
                                if length(rmsheight) > 1 && length(cl) == 1
                                    [f,x] = rsgene1D(surfpts,surflength,rmsheight(slopeindex),cl);
                                elseif length(rmsheight) > 1 && length(cl) > 1
                                    [f,x] = rsgene1D(surfpts,surflength,rmsheight(slopeindex),cl(slopeindex));
                                elseif length(rmsheight) == 1 && length(cl) > 1
                                    [f,x] = rsgene1D(surfpts,surflength,rmsheight,cl(slopeindex));
                                else
                                    [f,x] = rsgene1D(surfpts,surflength,rmsheight,cl);
                                end
                                handles.Results.acf = 'exp';
                            end
                            
                            %% ray-tracing
                            % load simulation parameters
                            n1 = str2double(get(handles.n1_edit,'String'));
                            k1 = str2double(get(handles.k1_edit,'String'));
                            n2 = str2double(get(handles.n2_edit,'String'));
                            k2 = str2double(get(handles.k2_edit,'String'));
                            nfrp = str2double(get(handles.rays_edit,'String'));
                            if get(handles.beamdist_popupmenu,'Value') == 1
                                dstrb = 'uni';
                            elseif get(handles.beamdist_popupmenu,'Value') == 2
                                dstrb = 'gauss';
                            end
                            br = str2double(get(handles.beamradius_edit,'String'));
                            prs = 0;
                            % save surface variables to handles structure
                            % (for exporting)
                            handles.Results.n1 = n1;
                            handles.Results.k1 = k1;
                            handles.Results.n2 = n2;
                            handles.Results.k2 = k2;
                            handles.Results.rays = nfrp;
                            handles.Results.beamdist = dstrb;
                            handles.Results.beamradius = br;
                            handles.Results.hdf = 'gauss';
                            handles.Results.surfpts = surfpts;
                            handles.Results.surflength = surflength;
                            handles.Results.rmsheight = rmsheight;
                            handles.Results.cl = cl;
                            try
                                [R,brdf,scatpts,shadowing,warnings] = goa2D(f,x,theta(thetaindex),n1,k1,n2,k2,nfrp,dstrb,br);
                            
                                elapsed = toc;
                                
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Realisation',num2str(realisation),'.R = R;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Realisation',num2str(realisation),'.brdf = brdf;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Realisation',num2str(realisation),'.scatpts = scatpts;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Realisation',num2str(realisation),'.shadowing = shadowing;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Realisation',num2str(realisation),'.warnings = warnings;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Realisation',num2str(realisation),'.elapsed = elapsed;'));
                                
                                handles.Results.Totals.DHR(slopeindex,thetaindex) = (R + (realisation-1)*handles.Results.Totals.DHR(slopeindex,thetaindex))/realisation;
                                handles.Results.Totals.brdf(slopeindex,thetaindex,:,:) = (brdf + (realisation-1)*squeeze(handles.Results.Totals.brdf(slopeindex,thetaindex,:,:)))/realisation;
                                handles.Results.Totals.scatpts(slopeindex,thetaindex) = (scatpts + (realisation-1)*handles.Results.Totals.scatpts(slopeindex,thetaindex))/realisation;
                                handles.Results.Totals.shadowing(slopeindex,thetaindex) = (shadowing + (realisation-1)*handles.Results.Totals.shadowing(slopeindex,thetaindex))/realisation;
                                handles.Results.Totals.warnings(slopeindex,thetaindex) = (warnings + (realisation-1)*handles.Results.Totals.warnings(slopeindex,thetaindex))/realisation;
                                
                                contents{listindex} = cat(2,'  Realisation',num2str(realisation));
                                listindex = listindex + 1;
                                realisationindex = realisationindex + 1; realisation = realisation + 1;
                                
                                handles.Results.Totals.elapsedtime(realisationindex) = elapsed;
                                timeleft = (numberofrealisations - realisationindex) * mean(nonzeros(handles.Results.Totals.elapsedtime));
                            catch exception
                                exception
                                handles.Results.Totals.errors(slopeindex,thetaindex) = handles.Results.Totals.errors(slopeindex,thetaindex) + 1; 
                            end


                        else % 2D surface
                            
                            %% surface generation
                            % load input parameters
                            surfpts = str2double(get(handles.surfpts_edit,'String'));
                            surflength = str2double(get(handles.surflength_edit,'String'));
                            
                            % check selected surface statistics
                            % acf
                            if get(handles.acf_popupmenu,'Value') == 1
                                if get(handles.noniso_checkbox,'Value')
                                    if length(rmsheight) > 1 && length(clx) == 1 && length(cly) == 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),clx,cly);
                                    elseif length(rmsheight) > 1 && length(clx) > 1 && length(cly) > 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),clx(slopeindex),cly(slopeindex));
                                    elseif length(rmsheight) > 1 && length(clx) > 1 && length(cly) == 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),clx(slopeindex),cly);
                                    elseif length(rmsheight) > 1 && length(clx) == 1 && length(cly) > 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),clx,cly(slopeindex));
                                    elseif length(rmsheight) > 1 && length(clx) == 1 && length(cly) == 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),clx,cly);
                                    elseif length(rmsheight) == 1 && length(clx) > 1 && length(cly) > 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight,clx(slopeindex),cly(slopeindex));
                                    elseif length(rmsheight) == 1 && length(clx) > 1 && length(cly) == 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight,clx(slopeindex),cly);
                                    elseif length(rmsheight) == 1 && length(clx) == 1 && length(cly) > 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight,clx,cly(slopeindex));
                                    elseif length(rmsheight) == 1 && length(clx) == 1 && length(cly) == 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight,clx,cly);
                                    end
                                else
                                    if length(rmsheight) > 1 && length(cl) > 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),cl(slopeindex));
                                    elseif length(rmsheight) > 1 && length(cl) == 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight(slopeindex),cl);
                                    elseif length(rmsheight) == 1 && length(cl) > 1
                                        [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight,cl(slopeindex));
                                    else [f,x,y] = rsgeng2D(surfpts,surflength,rmsheight,cl);
                                    end
                                    clx = cl; cly = cl;
                                end
                                handles.Results.acf = 'gauss';
                            elseif get(handles.acf_popupmenu,'Value') == 2
                                if get(handles.noniso_checkbox,'Value')
                                    if length(rmsheight) > 1 && length(clx) == 1 && length(cly) == 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),clx,cly);
                                    elseif length(rmsheight) > 1 && length(clx) > 1 && length(cly) > 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),clx(slopeindex),cly(slopeindex));
                                    elseif length(rmsheight) > 1 && length(clx) > 1 && length(cly) == 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),clx(slopeindex),cly);
                                    elseif length(rmsheight) > 1 && length(clx) == 1 && length(cly) > 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),clx,cly(slopeindex));
                                    elseif length(rmsheight) > 1 && length(clx) == 1 && length(cly) == 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),clx,cly);
                                    elseif length(rmsheight) == 1 && length(clx) > 1 && length(cly) > 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight,clx(slopeindex),cly(slopeindex));
                                    elseif length(rmsheight) == 1 && length(clx) > 1 && length(cly) == 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight,clx(slopeindex),cly);
                                    elseif length(rmsheight) == 1 && length(clx) == 1 && length(cly) > 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight,clx,cly(slopeindex));
                                    elseif length(rmsheight) == 1 && length(clx) == 1 && length(cly) == 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight,clx,cly);
                                    end
                                else
                                    if length(rmsheight) > 1 && length(cl) > 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),cl(slopeindex));
                                    elseif length(rmsheight) > 1 && length(cl) == 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight(slopeindex),cl);
                                    elseif length(rmsheight) == 1 && length(cl) > 1
                                        [f,x,y] = rsgene2D(surfpts,surflength,rmsheight,cl(slopeindex));
                                    else [f,x,y] = rsgene2D(surfpts,surflength,rmsheight,cl);
                                    end
                                    clx = cl; cly = cl;
                                end
                                handles.Results.acf = 'exp';
                            end
                            
                            %% ray-tracing
                            % load input parameters
                            n1 = str2double(get(handles.n1_edit,'String'));
                            k1 = str2double(get(handles.k1_edit,'String'));
                            n2 = str2double(get(handles.n2_edit,'String'));
                            k2 = str2double(get(handles.k2_edit,'String'));
                            nfrp = str2double(get(handles.rays_edit,'String'));
                            if get(handles.beamdist_popupmenu,'Value') == 1
                                dstrb = 'uni';
                            elseif get(handles.beamdist_popupmenu,'Value') == 2
                                dstrb = 'gauss';
                            end
                            br = str2double(get(handles.beamradius_edit,'String'));

                            % save surface variables to handles structure
                            % (for exporting)
                            handles.Results.n1 = n1;
                            handles.Results.k1 = k1;
                            handles.Results.n2 = n2;
                            handles.Results.k2 = k2;
                            handles.Results.rays = nfrp;
                            handles.Results.beamdist = dstrb;
                            handles.Results.beamradius = br;
                            handles.Results.hdf = 'gauss';
                            handles.Results.surfpts = surfpts;
                            handles.Results.surflength = surflength;
                            handles.Results.rmsheight = rmsheight;
                            handles.Results.clx = clx;
                            handles.Results.cly = cly;
                            
                            
                            try
                            
                                [R,brdf,scatpts,shadowing,warnings] = goa3D(f,x,y,theta(thetaindex),phi(phiindex),n1,k1,n2,k2,nfrp,dstrb,br);
                                
                                elapsed = toc;
                                
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.Realisation',num2str(realisation),'.R = R;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.Realisation',num2str(realisation),'.brdf = brdf;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.Realisation',num2str(realisation),'.scatpts = scatpts;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.Realisation',num2str(realisation),'.shadowing = shadowing;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.Realisation',num2str(realisation),'.warnings = warnings;'));
                                eval(cat(2,'handles.Results.Slope',num2str(slopeindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.Realisation',num2str(realisation),'.elapsed = elapsed;'));
                                
                                handles.Results.Totals.DHR(slopeindex,thetaindex, phiindex) = (R + (realisation-1)*handles.Results.Totals.DHR(slopeindex,thetaindex,phiindex))/realisation;
                                handles.Results.Totals.brdf(slopeindex,thetaindex,phiindex,:,:,:) = (brdf + (realisation-1)*squeeze(handles.Results.Totals.brdf(slopeindex,thetaindex,phiindex,:,:,:)))/realisation;
                                handles.Results.Totals.scatpts(slopeindex,thetaindex,phiindex) = (scatpts + (realisation-1)*handles.Results.Totals.scatpts(slopeindex,thetaindex,phiindex))/realisation;
                                handles.Results.Totals.shadowing(slopeindex,thetaindex,phiindex) = (shadowing + (realisation-1)*handles.Results.Totals.shadowing(slopeindex,thetaindex,phiindex))/realisation;
                                handles.Results.Totals.warnings(slopeindex,thetaindex,phiindex) = (warnings + (realisation-1)*handles.Results.Totals.warnings(slopeindex,thetaindex,phiindex))/realisation;
                                
                                contents{listindex} = cat(2,'    Realisation',num2str(realisation));
                                listindex = listindex + 1;
                                realisationindex = realisationindex + 1; realisation = realisation + 1; % go to next realisation
                                
                                handles.Results.Totals.elapsedtime(realisationindex) = elapsed;
                                timeleft = (numberofrealisations - realisationindex) * mean(nonzeros(handles.Results.Totals.elapsedtime));
                            
                            catch exception
                                exception
                                handles.Results.Totals.errors(slopeindex,thetaindex,phiindex) = handles.Results.Totals.errors(slopeindex,thetaindex,phiindex) + 1;
                            end
                            
                            
                            
                        end
                        
                        
                    end
                    
                end
                
            end
            
        end
        close(h);
        set(handles.results_listbox, 'String', contents);
        set(handles.results_listbox, 'Value', 1);
        
        guidata(GOA,handles);
        
        showsingleresults(handles);
        
        set(handles.brdfslope_popupmenu,'String',num2str(slopes'));
        set(handles.brdfslope_popupmenu,'Value',1);
        set(handles.brdftheta_popupmenu,'String',num2str(theta'));
        set(handles.brdftheta_popupmenu,'Value',1);
        if handles.Results.Dimension == 2
            set(handles.brdfphi_text,'Visible','on');
            set(handles.brdfphi_popupmenu,'String',num2str(phi'));
            set(handles.brdfphi_popupmenu,'Value',1);
            set(handles.brdfphi_popupmenu,'Visible','on');
            
            set(handles.plotslope3D_togglebutton,'Value',1);
            set(handles.plotvar3DA_text,'string','Theta');
            set(handles.plotvar3DB_text,'string','Phi');
            set(handles.plotvar3DA_listbox,'string',num2str(handles.Results.Thetas'));
            set(handles.plotvar3DA_listbox,'min',0); set(handles.plotvar3DA_listbox,'max',length(handles.Results.Thetas));
            set(handles.plotvar3DA_listbox,'value',1);
            set(handles.plotvar3DB_listbox,'string',num2str(handles.Results.Phis'));
            set(handles.plotvar3DB_listbox,'min',0); set(handles.plotvar3DB_listbox,'max',1);
            set(handles.plotvar3DB_listbox,'value',1);
            
            set(handles.brdfslope_text,'Visible','on');
            set(handles.brdfslope_popupmenu,'Visible','on');
            
            set(handles.brdftheta_text,'Visible','on');
            set(handles.brdftheta_popupmenu,'Visible','on');
            
            set(handles.phiplot_text,'Visible','on');
            set(handles.phi2_popupmenu,'Visible','on');
            set(handles.phi2_popupmenu,'String',num2str([0:10:170]'));
        else
            set(handles.plotslope2D_togglebutton,'Value',1);
            set(handles.plotvar2D_text,'string','Theta');
            set(handles.plotvar2D_listbox,'string',num2str(handles.Results.Thetas'));
            set(handles.plotvar2D_listbox,'min',0); set(handles.plotvar2D_listbox,'max',length(handles.Results.Thetas));
            set(handles.plotvar2D_listbox,'value',1);
            set(handles.brdfphi_text,'Visible','off');
            set(handles.brdfphi_popupmenu,'Visible','off');
            
            set(handles.phiplot_text,'Visible','off');
            set(handles.phi2_popupmenu,'Visible','off');
        end
        
        showtotalresults(handles);
        
        set(handles.singleresults_panel,'Visible','on');
        set(handles.totalresults_panel,'Visible','on');
    end
    
else % mode 1
    
    if checkinput(handles)
        set(handles.singleresults_panel,'Visible','off');
        set(handles.totalresults_panel,'Visible','off');
        
        set(handles.results_listbox,'String','');
        contents_results = cellstr('');
        set(handles.results_listbox, 'Value', 0);
        
        contents_surfaces = get(handles.surf_listbox,'String');
        nsurf = length(contents_surfaces);
        first_item = contents_surfaces{1};
        if strcmp(first_item(end-2:end-1),'1D')
            dim = 1;
        else
            dim = 2;
        end
        
        % calculate number of angles
        theta = str2num(get(handles.theta_edit,'String'));
        phi = str2num(get(handles.phi_edit,'String'));
        numberofthetas = length(theta);
        if length(phi) > 1 && dim == 2
            numberofphis = length(phi);
        else numberofphis = 1;
        end
        
        numberofrealisations = nsurf*numberofthetas*numberofphis;
        handles.Results.Totals.elapsedtime = zeros(1,numberofrealisations);
        
        if isfield(handles,'Results')
            handles = rmfield(handles,'Results'); % reset results
        end
        
        % intialize results
        handles.Results.Mode = 1;
        if dim == 1
            handles.Results.Dimension = 1;
            handles.Results.Thetas = theta;
            handles.Results.Totals.DHR = zeros(1,numberofthetas);
            handles.Results.Totals.brdf = zeros(numberofthetas,3,181);
            handles.Results.Totals.scatpts = zeros(1,numberofthetas);
            handles.Results.Totals.shadowing = zeros(1,numberofthetas);
            handles.Results.Totals.warnings = zeros(1,numberofthetas);
            handles.Results.Totals.errors = zeros(1,numberofthetas);
        else handles.Results.Dimension = 2;
            handles.Results.Thetas = theta;
            handles.Results.Phis = phi;
            handles.Results.Totals.DHR = zeros(numberofthetas,numberofphis);
            handles.Results.Totals.brdf = zeros(numberofthetas,numberofphis,3,91,360);
            handles.Results.Totals.scatpts = zeros(numberofthetas,numberofphis);
            handles.Results.Totals.shadowing = zeros(numberofthetas,numberofphis);
            handles.Results.Totals.warnings = zeros(numberofthetas,numberofphis);
            handles.Results.Totals.errors = zeros(1,numberofthetas,numberofphis);
        end

        h = waitbar(0);
        listindex = 1; realisationindex = 1;
        
        for surfindex = 1:nsurf
            [path, name] = fileparts(contents_surfaces{surfindex});
            contents_results{listindex} = contents_surfaces{surfindex};
            listindex = listindex + 1;
            
            for thetaindex = 1:numberofthetas
                contents_results{listindex} = cat(2,' Theta',num2str(theta(thetaindex)));
                listindex = listindex + 1;
                
                for phiindex = 1:numberofphis
                    
                    if dim == 2
                        contents_results{listindex} = cat(2,'  Phi',num2str(phi(phiindex)));
                        listindex = listindex + 1;
                    end
                    
                    if realisationindex == 1
                        msg = cat(2,'Processing surface ',num2str(realisationindex),' of ',num2str(numberofrealisations),'. Appr. \infty [s] left.');
                    else
                        msg = cat(2,'Processing surface ',num2str(realisationindex),' of ',num2str(numberofrealisations),'. Appr. ',num2str(timeleft,'%.0f'),' [s] left.');
                    end
                    waitbar(realisationindex/numberofrealisations,h,msg,'Position',[100 100 500 200]);
                    
                    tic;
                    
                    surface = load(fullfile(path,name));
                    f = surface.f;
                    x = surface.x;
                    if dim == 2
                        y = surface.y;
                    end
                    surfpts = length(x);
                    surflength = x(end)-x(1);
                    
                    % load simulation parameters
                    n1 = str2double(get(handles.n1_edit,'String'));
                    k1 = str2double(get(handles.k1_edit,'String'));
                    n2 = str2double(get(handles.n2_edit,'String'));
                    k2 = str2double(get(handles.k2_edit,'String'));
                    nfrp = str2double(get(handles.rays_edit,'String'))/100*surfpts;
                    if get(handles.beamdist_popupmenu,'Value') == 1
                        dstrb = 'uni';
                    elseif get(handles.beamdist_popupmenu,'Value') == 2
                        dstrb = 'gauss';
                    end
                    br = str2double(get(handles.beamradius_edit,'String'))/100*surflength;
                    prs = 0;
                    % save surface variables to handles structure
                    % (for exporting)
                    handles.Results.n1 = n1;
                    handles.Results.k1 = k1;
                    handles.Results.n2 = n2;
                    handles.Results.k2 = k2;
                    handles.Results.rays = nfrp;
                    handles.Results.beamdist = dstrb;
                    handles.Results.beamradius = br;
%                     handles.Results.hdf = 'gauss';
%                     handles.Results.surfpts = surfpts;
%                     handles.Results.surflength = surflength;
%                     handles.Results.rmsheight = rmsheight;
%                     handles.Results.clx = clx;
%                     handles.Results.cly = cly;
                    
                    if handles.Results.Dimension == 1 % 2D scattering
                        
                        try
                            
                            [R,brdf,scatpts,shadowing,warnings] = goa2D(f,x,theta(thetaindex),n1,k1,n2,k2,nfrp,dstrb,br,prs);
                            
                            elapsed = toc;
                            
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.R = R;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.brdf = brdf;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.scatpts = scatpts;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.shadowing = shadowing;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.warnings = warnings;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.elapsed = elapsed;'));
                            
                            handles.Results.Totals.DHR(thetaindex) = (R + (surfindex-1)*handles.Results.Totals.DHR(thetaindex))/surfindex;
                            handles.Results.Totals.brdf(thetaindex,:,:) = (brdf + (surfindex-1)*squeeze(handles.Results.Totals.brdf(thetaindex,:,:)))/surfindex;
                            handles.Results.Totals.scatpts(thetaindex) = (scatpts + (surfindex-1)*handles.Results.Totals.scatpts(thetaindex))/surfindex;
                            handles.Results.Totals.shadowing(thetaindex) = (shadowing + (surfindex-1)*handles.Results.Totals.shadowing(thetaindex))/surfindex;
                            handles.Results.Totals.warnings(thetaindex) = (warnings + (surfindex-1)*handles.Results.Totals.warnings(thetaindex))/surfindex;
                        
                            realisationindex = realisationindex + 1;
                            handles.Results.Totals.elapsedtime(realisationindex) = elapsed;
                            timeleft = (numberofrealisations - realisationindex) * mean(nonzeros(handles.Results.Totals.elapsedtime));
                            
                        catch
                            handles.Results.Totals.errors(surfindex,thetaindex) = handles.Results.Totals.errors(surfindex,thetaindex) + 1; 
                            elapsed = toc;
                        end

                    else % 3D scattering
                        
                        try
                            
                            [R,brdf,scatpts,shadowing,warnings] = goa3D(f,x,y,theta(thetaindex),phi(phiindex),n1,k1,n2,k2,nfrp,dstrb,br,prs);
                            
                            elapsed = toc;
                            
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.R = R;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.brdf = brdf;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.scatpts = scatpts;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.shadowing = shadowing;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.warnings = warnings;'));
                            eval(cat(2,'handles.Results.Surface',num2str(surfindex),'.Theta',num2str(thetaindex),'.Phi',num2str(phiindex),'.elapsed = elapsed;'));
                            
                            handles.Results.Totals.DHR(thetaindex, phiindex) = (R + (surfindex-1)*handles.Results.Totals.DHR(thetaindex,phiindex))/surfindex;
                            handles.Results.Totals.brdf(thetaindex,phiindex,:,:,:) = (brdf + (surfindex-1)*squeeze(handles.Results.Totals.brdf(thetaindex,phiindex,:,:,:)))/surfindex;
                            handles.Results.Totals.scatpts(thetaindex,phiindex) = (scatpts + (surfindex-1)*handles.Results.Totals.scatpts(thetaindex,phiindex))/surfindex;
                            handles.Results.Totals.shadowing(thetaindex,phiindex) = (shadowing + (surfindex-1)*handles.Results.Totals.shadowing(thetaindex,phiindex))/surfindex;
                            handles.Results.Totals.warnings(thetaindex,phiindex) = (warnings + (surfindex-1)*handles.Results.Totals.warnings(thetaindex,phiindex))/surfindex;
                            
                            realisationindex = realisationindex + 1;
                            handles.Results.Totals.elapsedtime(realisationindex) = elapsed;
                            timeleft = (numberofrealisations - realisationindex) * mean(nonzeros(handles.Results.Totals.elapsedtime));

                        catch
                            handles.Results.Totals.errors(surfindex,thetaindex,phiindex) = handles.Results.Totals.errors(surfindex,thetaindex,phiindex) + 1; 
                            elapsed = toc;
                        end
                        
                        
                        
                    end
                                        
                    
                end
            
            end
            
        end
        close(h);
        set(handles.results_listbox, 'String', contents_results);
        set(handles.results_listbox, 'Value', 1);
        
        guidata(GOA,handles);
        
        set(handles.brdfslope_text,'Visible','off');
        set(handles.brdfslope_popupmenu,'Visible','off');
        
        set(handles.brdftheta_popupmenu,'String',num2str(theta'));
        set(handles.brdftheta_popupmenu,'Value',1);
        set(handles.brdftheta_text,'Visible','on');
        set(handles.brdftheta_popupmenu,'Visible','on');
        
        set(handles.brdfphi_text,'Visible','off');
        set(handles.brdfphi_popupmenu,'Visible','off');
        if handles.Results.Dimension == 1
            set(handles.phiplot_text,'Visible','off');
            set(handles.phi2_popupmenu,'Visible','off');
        else
            set(handles.plottheta3D_togglebutton,'Value',1);
            set(handles.plotvar3DA_text,'String','Phi');
            set(handles.plotvar3DA_listbox,'String',num2str(handles.Results.Phis'));
            set(handles.plotvar3DA_listbox,'Min',0); set(handles.plotvar3DA_listbox,'Max',length(handles.Results.Phis));
            set(handles.plotvar3DA_listbox,'Value',1);

            set(handles.plotvar3DB_text,'String','n/a');
            set(handles.plotvar3DB_listbox,'Value',1);
            set(handles.plotvar3DB_listbox,'String','');
            set(handles.plotvar3DB_listbox,'Enable','off');
            
            set(handles.phiplot_text,'Visible','on');
            set(handles.phi2_popupmenu,'Visible','on');
            set(handles.phi2_popupmenu,'String',num2str([0:10:170]'));
        end
        
        showsingleresults(handles);
        showtotalresults(handles);
        
        set(handles.singleresults_panel,'Visible','on');
        set(handles.totalresults_panel,'Visible','on');

    end
    
end


%% Show single realisation/surface results
function showsingleresults(handles)

contents = get(handles.results_listbox,'String');
realisation_str = contents{get(handles.results_listbox,'Value')};


if handles.Results.Dimension == 1 % 2D scattering
    
    if handles.Results.Mode == 2 %% Monte Carlo mode
        
        realisation_str = realisation_str(3:end);
        
        if length(realisation_str) >= 12 
            
            if strcmp(realisation_str(1:11),'Realisation') % realisation found (= show results)
            
                showresults = 1;
                
                listindex = get(handles.results_listbox,'Value') - 1;
                
                theta_str = contents{listindex};
                % find theta
                while ~strcmp(theta_str(2:6),'Theta')
                    listindex = listindex - 1;
                    theta_str = contents{listindex};
                end
                ind = find(handles.Results.Thetas == str2double(theta_str(7:end)));
                theta_str = cat(2,'Theta',num2str(ind));
                listindex = listindex - 1;
                slope_str = contents{listindex};
                % find slope
                while ~strcmp(slope_str(1:5),'Slope')
                    listindex = listindex - 1;
                    slope_str = contents{listindex};
                end
                ind = find(handles.Results.Slopes == str2double(slope_str(6:end)));
                ok = 0;
                while isempty(ind)
                    listindex = listindex - 1;
                    if listindex > 0
                        slope_str = contents{listindex};
                        % find slope
                        while ~strcmp(slope_str(1:5),'Slope')
                            listindex = listindex - 1;
                            slope_str = contents{listindex};
                        end
                        ind = find(handles.Results.Slopes == str2double(slope_str(6:end)));
                        ok = ok + 1;
                    else
                        ind = 1;
                    end
                end
                ind = ind + ok;
                slope_str = cat(2,'Slope',num2str(ind));
                
                eval(cat(2,'R = handles.Results.',slope_str,'.',theta_str,'.',realisation_str,'.R;'));
                eval(cat(2,'brdf = handles.Results.',slope_str,'.',theta_str,'.',realisation_str,'.brdf;'));
                eval(cat(2,'scatpts = handles.Results.',slope_str,'.',theta_str,'.',realisation_str,'.scatpts;'));
                eval(cat(2,'shadowing = handles.Results.',slope_str,'.',theta_str,'.',realisation_str,'.shadowing;'));
                eval(cat(2,'warnings = handles.Results.',slope_str,'.',theta_str,'.',realisation_str,'.warnings;'));
                eval(cat(2,'elapsed = handles.Results.',slope_str,'.',theta_str,'.',realisation_str,'.elapsed;'));
            
            end
        else
            showresults = 0; 
        end
        
    else %% Mode 1
        
        if isspace(realisation_str(1)) % theta found (= show results)
            
            showresults = 1; 
            
            ind = find(handles.Results.Thetas == str2double(realisation_str(7:end)));
            theta_str = cat(2,'Theta',num2str(ind));
            listindex = get(handles.results_listbox,'Value') - 1;
            
            surf_str = contents{listindex};
            % find surface
            while isspace(surf_str(1))
                listindex = listindex - 1;
                surf_str = contents{listindex};
            end
            
            contents_surfaces = get(handles.surf_listbox,'String');
            surfindex = find(ismember(contents_surfaces, surf_str)==1);
            surf_str = cat(2,'Surface',num2str(surfindex));
            
            eval(cat(2,'R = handles.Results.',surf_str,'.',theta_str,'.R;'));
            eval(cat(2,'brdf = handles.Results.',surf_str,'.',theta_str,'.brdf;'));
            eval(cat(2,'scatpts = handles.Results.',surf_str,'.',theta_str,'.scatpts;'));
            eval(cat(2,'shadowing = handles.Results.',surf_str,'.',theta_str,'.shadowing;'));
            eval(cat(2,'warnings = handles.Results.',surf_str,'.',theta_str,'.warnings;'));
            eval(cat(2,'elapsed = handles.Results.',surf_str,'.',theta_str,'.elapsed;'));
            set(handles.singleresults_panel2,'Visible','on');
        else
            showresults = 0;  
        end
        
    end
    
    if showresults
        %% display results
        set(handles.DHR_text,'String',num2str(R,'%3.2f'));
        set(handles.scatpts_text,'String',num2str(scatpts,'%3.2f'));
        set(handles.shadowing_text,'String',cat(2,num2str(100*shadowing,'%4.1f'),'%'));
        set(handles.warnings_text,'String',cat(2,num2str(100*warnings,'%4.1f'),'%'));
        set(handles.runtime_text,'String',cat(2,num2str(elapsed,'%.2f'),' [s]'));
        cla(handles.brdf_axes);
        plot(handles.brdf_axes,-90:1:90,sum(brdf),'-k'); hold(handles.brdf_axes,'on');
        plot(handles.brdf_axes,-90:1:90,brdf(1,:),'-b'); hold(handles.brdf_axes,'on');
        plot(handles.brdf_axes,-90:1:90,brdf(2,:),'-g'); hold(handles.brdf_axes,'on');
        plot(handles.brdf_axes,-90:1:90,brdf(3,:),'-r'); legend(handles.brdf_axes,'total','1st','2nd','3rd','Location','EastOutside');
        grid(handles.brdf_axes,'on'); axis(handles.brdf_axes,[-90 90 0 max(sum(brdf(:,5:end-5)))]); set(handles.brdf_axes,'XTick',[-90,-45,0,45,90]);
        xlabel(handles.brdf_axes,'\theta','FontSize',8); ylabel(handles.brdf_axes,'BRDF','FontSize',7);
        
        set(handles.singleresults_panel2,'Visible','on');
    else
        set(handles.singleresults_panel2,'Visible','off');
    end
    
    
else % 3D scattering
    
    if handles.Results.Mode == 2 %% Monte Carlo mode
        
        realisation_str = realisation_str(4:end);
        
        if length(realisation_str) >= 12
            
            if strcmp(realisation_str(1:11),'Realisation') % realisation found (= show results)
                
                showresults = 1;
                listindex = get(handles.results_listbox,'Value') - 1;
                
                phi_str = contents{listindex};
                % find phi
                while ~strcmp(phi_str(3:5),'Phi')
                    listindex = listindex - 1;
                    phi_str = contents{listindex};
                end
                ind = find(handles.Results.Phis == str2double(phi_str(6:end)));
                phi_str = cat(2,'Phi',num2str(ind));
                listindex = listindex - 1;
                theta_str = contents{listindex};
                % find theta
                while ~strcmp(theta_str(2:6),'Theta')
                    listindex = listindex - 1;
                    theta_str = contents{listindex};
                end
                ind = find(handles.Results.Thetas == str2double(theta_str(7:end)));
                theta_str = cat(2,'Theta',num2str(ind));
                listindex = listindex - 1;
                slope_str = contents{listindex};
                % find slope
                while ~strcmp(slope_str(1:5),'Slope')
                    listindex = listindex - 1;
                    slope_str = contents{listindex};
                end
                ind = find(handles.Results.Slopes == str2double(slope_str(6:end)));
                ok = 0;
                while isempty(ind)
                    listindex = listindex - 1;
                    if listindex > 0
                        slope_str = contents{listindex};
                        % find slope
                        while ~strcmp(slope_str(1:5),'Slope')
                            listindex = listindex - 1;
                            slope_str = contents{listindex};
                        end
                        ind = find(handles.Results.Slopes == str2double(slope_str(6:end)));
                        ok = ok + 1;
                    else
                        ind = 1;
                    end
                end
                ind = ind + ok;
                slope_str = cat(2,'Slope',num2str(ind));
                
                eval(cat(2,'R = handles.Results.',slope_str,'.',theta_str,'.',phi_str,'.',realisation_str,'.R;'));
                eval(cat(2,'brdf = handles.Results.',slope_str,'.',theta_str,'.',phi_str,'.',realisation_str,'.brdf;'));
                eval(cat(2,'scatpts = handles.Results.',slope_str,'.',theta_str,'.',phi_str,'.',realisation_str,'.scatpts;'));
                eval(cat(2,'shadowing = handles.Results.',slope_str,'.',theta_str,'.',phi_str,'.',realisation_str,'.shadowing;'));
                eval(cat(2,'warnings = handles.Results.',slope_str,'.',theta_str,'.',phi_str,'.',realisation_str,'.warnings;'));
                eval(cat(2,'elapsed = handles.Results.',slope_str,'.',theta_str,'.',phi_str,'.',realisation_str,'.elapsed;'));
                
            end
            
        else
            showresults = 0;
        end
        
    else % Mode 1
        if isspace(realisation_str(2)) % phi found (= show results)
            
            showresults = 1;
            
            ind = find(handles.Results.Phis == str2double(realisation_str(6:end)));
            phi_str = cat(2,'Phi',num2str(ind));
            listindex = get(handles.results_listbox,'Value') - 1;
            
            theta_str = contents{listindex};
            % find surface
            while isspace(theta_str(2))
                listindex = listindex - 1;
                theta_str = contents{listindex};
            end
            
            ind = find(handles.Results.Thetas == str2double(theta_str(7:end)));
            theta_str = cat(2,'Theta',num2str(ind));
            listindex = listindex - 1;
            
            surf_str = contents{listindex};
            % find surface
            while isspace(surf_str(1))
                listindex = listindex - 1;
                surf_str = contents{listindex};
            end
            
            contents_surfaces = get(handles.surf_listbox,'String');
            surfindex = find(ismember(contents_surfaces, surf_str)==1);
            surf_str = cat(2,'Surface',num2str(surfindex));
            
            eval(cat(2,'R = handles.Results.',surf_str,'.',theta_str,'.',phi_str,'.R;'));
            eval(cat(2,'brdf = handles.Results.',surf_str,'.',theta_str,'.',phi_str,'.brdf;'));
            eval(cat(2,'scatpts = handles.Results.',surf_str,'.',theta_str,'.',phi_str,'.scatpts;'));
            eval(cat(2,'shadowing = handles.Results.',surf_str,'.',theta_str,'.',phi_str,'.shadowing;'));
            eval(cat(2,'warnings = handles.Results.',surf_str,'.',theta_str,'.',phi_str,'.warnings;'));
            eval(cat(2,'elapsed = handles.Results.',surf_str,'.',theta_str,'.',phi_str,'.elapsed;'));
            
            set(handles.singleresults_panel2,'Visible','on');
        else
            showresults = 0;
        end
    end
    
    if showresults
        % display results
        set(handles.DHR_text,'String',num2str(R,'%3.2f'));
        set(handles.scatpts_text,'String',num2str(scatpts,'%3.2f'));
        set(handles.shadowing_text,'String',cat(2,num2str(100*shadowing,'%4.1f'),'%'));
        set(handles.warnings_text,'String',cat(2,num2str(100*warnings,'%4.1f'),'%'));
        set(handles.runtime_text,'String',cat(2,num2str(elapsed,'%.2f'),' [s]'));
        cla(handles.brdf_axes);
        
        phi = str2num(get(handles.phi_edit,'String'));
        phi_index = str2double(phi_str(4:end));
        phi = phi(phi_index);
        if phi >= 0 && phi < 180
            phi2 = phi + 180;
        else
            phi2 = phi - 180;
        end
        if nnz(brdf) > 0 % non-zero elements exist
            if phi <= 5
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:phi2),3) + sum(brdf(:,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(sum(brdf(:,1,phi2-5:phi2),3) + sum(brdf(:,1,phi2+1:phi2+5),3),1) + sum(sum(brdf(:,1,phi+360-5:360),3) + sum(brdf(:,1,1:phi+5),3),1)...
                    fliplr(sum(sum(brdf(:,2:91,phi+360-5:360),3) + sum(brdf(:,2:91,1:phi+5),3),1))]),'-k'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(brdf(1,2:91,phi2-5:phi2),3) +sum(brdf(1,2:91,phi2+1:phi2+5),3)) ...
                    sum(brdf(1,1,phi2-5:phi2),3) + sum(brdf(1,1,phi2+1:phi2+5),3) + sum(brdf(1,1,phi+360-5:360),3) + sum(brdf(1,1,1:phi+5),3)...
                    fliplr(sum(brdf(1,2:91,phi+360-5:360),3) + sum(brdf(1,2:91,1:phi+5),3))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(brdf(2,2:91,phi2-5:phi2),3) +sum(brdf(2,2:91,phi2+1:phi2+5),3)) ...
                    sum(brdf(2,1,phi2-5:phi2),3) + sum(brdf(2,1,phi2+1:phi2+5),3) + sum(brdf(2,1,phi+360-5:360),3) + sum(brdf(2,1,1:phi+5),3)...
                    fliplr(sum(brdf(2,2:91,phi+360-5:360),3) + sum(brdf(2,2:91,1:phi+5),3))]),'-g'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(brdf(3,2:91,phi2-5:phi2),3) +sum(brdf(3,2:91,phi2+1:phi2+5),3)) ...
                    sum(brdf(3,1,phi2-5:phi2),3) + sum(brdf(3,1,phi2+1:phi2+5),3) + sum(brdf(3,1,phi+360-5:360),3) + sum(brdf(3,1,1:phi+5),3)...
                    fliplr(sum(brdf(3,2:91,phi+360-5:360),3) + sum(brdf(3,2:91,1:phi+5),3))]),'-r'); hold(handles.brdf_axes,'on');
            elseif phi >= 356
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:phi2),3) + sum(brdf(:,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(sum(brdf(:,1,phi2-5:phi2),3) + sum(brdf(:,1,phi2+1:phi2+5),3),1) + sum(sum(brdf(:,1,phi-5:360),3) + sum(brdf(:,1,1:10-(360-(phi-5))),3),1)...
                    fliplr(sum(sum(brdf(:,2:91,phi-5:360),3) + sum(brdf(:,2:91,10-(360-(phi-5))),3),1))]),'-k'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(1,2:91,phi2-5:phi2),3) + sum(brdf(1,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(brdf(1,1,phi2-5:phi2),3) + sum(brdf(1,1,phi2+1:phi2+5),3) + sum(brdf(1,1,phi-5:360),3) + sum(brdf(1,1,1:10-(360-(phi-5))),3)...
                    fliplr(sum(sum(brdf(1,2:91,phi-5:360),3) + sum(brdf(1,2:91,10-(360-(phi-5))),3),1))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(2,2:91,phi2-5:phi2),3) + sum(brdf(2,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(brdf(2,1,phi2-5:phi2),3) + sum(brdf(2,1,phi2+1:phi2+5),3) + sum(brdf(2,1,phi-5:360),3) + sum(brdf(2,1,1:10-(360-(phi-5))),3)...
                    fliplr(sum(sum(brdf(2,2:91,phi-5:360),3) + sum(brdf(2,2:91,10-(360-(phi-5))),3),1))]),'-g'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(3,2:91,phi2-5:phi2),3) + sum(brdf(3,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(brdf(3,1,phi2-5:phi2),3) + sum(brdf(3,1,phi2+1:phi2+5),3) + sum(brdf(3,1,phi-5:360),3) + sum(brdf(3,1,1:10-(360-(phi-5))),3)...
                    fliplr(sum(sum(brdf(3,2:91,phi-5:360),3) + sum(brdf(3,2:91,10-(360-(phi-5))),3),1))]),'-r'); hold(handles.brdf_axes,'on');
            elseif phi2 <= 5
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2+360-5:360),3) + sum(brdf(:,2:91,1:phi2+5),3),1)) ...
                    sum(sum(brdf(:,1,phi2+360-5:360),3) + sum(brdf(:,1,1:phi2+5),3),1) + sum(sum(brdf(:,1,phi-5:phi),3) + sum(brdf(:,1,phi+1:phi+5),3),1)...
                    fliplr(sum(sum(brdf(:,2:91,phi-5:phi),3) + sum(brdf(:,2:91,phi+1:phi+5),3),1))]),'-k'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(brdf(1,2:91,phi2+360-5:360),3) +sum(brdf(1,2:91,1:phi2+5),3)) ...
                    sum(brdf(1,1,phi2+360-5:360),3) + sum(brdf(1,1,1:phi2+5),3) + sum(brdf(1,1,phi-5:phi),3) + sum(brdf(1,1,phi+1:phi+5),3)...
                    fliplr(sum(brdf(1,2:91,phi-5:phi),3) + sum(brdf(1,2:91,phi+1:phi+5),3))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(brdf(2,2:91,phi2+360-5:360),3) +sum(brdf(2,2:91,1:phi2+5),3)) ...
                    sum(brdf(2,1,phi2+360-5:360),3) + sum(brdf(2,1,1:phi2+5),3) + sum(brdf(2,1,phi-5:phi),3) + sum(brdf(2,1,phi+1:phi+5),3)...
                    fliplr(sum(brdf(2,2:91,phi-5:phi),3) + sum(brdf(2,2:91,phi+1:phi+5),3))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(brdf(3,2:91,phi2+360-5:360),3) +sum(brdf(3,2:91,1:phi2+5),3)) ...
                    sum(brdf(3,1,phi2+360-5:360),3) + sum(brdf(3,1,1:phi2+5),3) + sum(brdf(3,1,phi-5:phi),3) + sum(brdf(3,1,phi+1:phi+5),3)...
                    fliplr(sum(brdf(3,2:91,phi-5:phi),3) + sum(brdf(3,2:91,phi+1:phi+5),3))]),'-b'); hold(handles.brdf_axes,'on');
            elseif phi2 >= 356
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:360),3) + sum(brdf(:,2:91,10-(360-(phi2-5))),3),1)) ...
                    sum(sum(brdf(:,1,phi2-5:360),3) + sum(brdf(:,1,10-(360-(phi2-5))),3),1) + sum(sum(brdf(:,1,phi-5:phi),3) + sum(brdf(:,1,phi+1:phi+5),3),1)...
                    fliplr(sum(sum(brdf(:,2:91,phi-5:phi),3) + sum(brdf(:,2:91,phi+1:phi+5),3),1))]),'-k'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(1,2:91,phi2-5:360),3) + sum(brdf(1,2:91,10-(360-(phi2-5))),3),1)) ...
                    sum(brdf(1,1,phi2-5:360),3) + sum(brdf(1,1,10-(360-(phi2-5))),3) + sum(brdf(1,1,phi-5:phi),3) + sum(brdf(1,1,phi+1:phi+5),3)...
                    fliplr(sum(sum(brdf(1,2:91,phi-5:phi),3) + sum(brdf(1,2:91,phi+1:phi+5),3),1))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(2,2:91,phi2-5:360),3) + sum(brdf(2,2:91,10-(360-(phi2-5))),3),1)) ...
                    sum(brdf(2,1,phi2-5:360),3) + sum(brdf(2,1,10-(360-(phi2-5))),3) + sum(brdf(2,1,phi-5:phi),3) + sum(brdf(2,1,phi+1:phi+5),3)...
                    fliplr(sum(sum(brdf(2,2:91,phi-5:phi),3) + sum(brdf(2,2:91,phi+1:phi+5),3),1))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(3,2:91,phi2-5:360),3) + sum(brdf(3,2:91,10-(360-(phi2-5))),3),1)) ...
                    sum(brdf(3,1,phi2-5:360),3) + sum(brdf(3,1,10-(360-(phi2-5))),3) + sum(brdf(3,1,phi-5:phi),3) + sum(brdf(3,1,phi+1:phi+5),3)...
                    fliplr(sum(sum(brdf(3,2:91,phi-5:phi),3) + sum(brdf(3,2:91,phi+1:phi+5),3),1))]),'-b'); hold(handles.brdf_axes,'on');
            else
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:phi2),3) + sum(brdf(:,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(sum(brdf(:,1,phi2-5:phi2),3) + sum(brdf(:,1,phi2+1:phi2+5),3),1) +  sum(sum(brdf(:,1,phi-5:phi),3) + sum(brdf(:,1,phi+1:phi+5),3),1) ...
                    fliplr(sum(sum(brdf(:,2:91,phi-5:phi),3) + sum(brdf(:,2:91,phi+1:phi+5),3),1))]),'-k'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(1,2:91,phi2-5:phi2),3) + sum(brdf(1,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(brdf(1,1,phi2-5:phi2),3) + sum(brdf(1,1,phi2+1:phi2+5),3) +  sum(brdf(1,1,phi-5:phi),3) + sum(brdf(1,1,phi+1:phi+5),3) ...
                    fliplr(sum(sum(brdf(1,2:91,phi-5:phi),3) + sum(brdf(1,2:91,phi+1:phi+5),3),1))]),'-b'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(2,2:91,phi2-5:phi2),3) + sum(brdf(2,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(brdf(2,1,phi2-5:phi2),3) + sum(brdf(2,1,phi2+1:phi2+5),3) +  sum(brdf(2,1,phi-5:phi),3) + sum(brdf(2,1,phi+1:phi+5),3) ...
                    fliplr(sum(sum(brdf(2,2:91,phi-5:phi),3) + sum(brdf(2,2:91,phi+1:phi+5),3),1))]),'-g'); hold(handles.brdf_axes,'on');
                plot(handles.brdf_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(3,2:91,phi2-5:phi2),3) + sum(brdf(3,2:91,phi2+1:phi2+5),3),1)) ...
                    sum(brdf(3,1,phi2-5:phi2),3) + sum(brdf(3,1,phi2+1:phi2+5),3) +  sum(brdf(3,1,phi-5:phi),3) + sum(brdf(3,1,phi+1:phi+5),3) ...
                    fliplr(sum(sum(brdf(3,2:91,phi-5:phi),3) + sum(brdf(3,2:91,phi+1:phi+5),3),1))]),'-r'); hold(handles.brdf_axes,'on');
            end
            hold(handles.brdf_axes,'on'); legend(handles.brdf_axes,'tot','1st','2nd','3rd','Location','EastOutside');
            grid(handles.brdf_axes,'on'); axis(handles.brdf_axes,[-90 90 0 1]); axis(handles.brdf_axes,'auto y'); set(handles.brdf_axes,'XTick',[-90,-45,0,45,90]);
            xlabel(handles.brdf_axes,'\theta','FontName','Verdana','FontSize',8); ylabel(handles.brdf_axes,'BRDF','FontSize',7)
        end
        
        set(handles.singleresults_panel2,'Visible','on');
    else
        set(handles.singleresults_panel2,'Visible','off');
    end
end



%% Show total (ensemble) results
function showtotalresults(handles)

set(handles.runtime_text2,'String',cat(2,num2str(sum(handles.Results.Totals.elapsedtime),'%.2f'),' [s]'));
set(handles.errors_text,'String',num2str(sum(sum(sum(handles.Results.Totals.errors)))));

if handles.Results.Dimension == 1 % 2D scattering
    set(handles.plotoptions3D_panel,'Visible','off');
    set(handles.brdfplot_panel,'Visible','off');
    set(handles.phiplot_text,'Visible','off');
    set(handles.phi2_popupmenu,'Visible','off');
    
    if handles.Results.Mode == 1 % Mode 1
        set(handles.plotoptions2D_panel,'Visible','off');
    else
        set(handles.plotoptions2D_panel,'Visible','on');
        n = get(handles.plotvar2D_listbox,'Value');
    end
    
    % plot directional-hemispherical reflectance (DHR)
    cla(handles.DHR_axes);
    set(handles.DHR_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1 % Mode 1
            plot(handles.DHR_axes,handles.Results.Thetas,handles.Results.Totals.DHR,'-*');
            axis(handles.DHR_axes,[0 max(handles.Results.Thetas) 0 1]); set(handles.DHR_axes,'XTickMode','auto'); hold(handles.DHR_axes,'on');
            xlabel(handles.DHR_axes,'\theta','FontSize',8)
        else % Monte Carlo mode
            if get(handles.plotslope2D_togglebutton,'Value')
                plot(handles.DHR_axes,handles.Results.Slopes,handles.Results.Totals.DHR(:,n),'-*');
                axis(handles.DHR_axes,[0 max(handles.Results.Slopes) 0 1]); set(handles.DHR_axes,'XTickMode','auto'); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'slope','FontSize',7)
            else
                plot(handles.DHR_axes,handles.Results.Thetas,handles.Results.Totals.DHR(n,:),'-*');
                axis(handles.DHR_axes,[0 90 0 1]); set(handles.DHR_axes,'XTick',[0,30,60,90]); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'\theta','FontSize',8)
            end
        end
        grid(handles.DHR_axes,'on'); ylabel(handles.DHR_axes,'DHR','FontSize',7)
        
        % plot mean number of scattering points
        cla(handles.scattering_axes);
        set(handles.scattering_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1 % Mode 1
            plot(handles.scattering_axes,handles.Results.Thetas,handles.Results.Totals.scatpts,'-*');
            axis(handles.scattering_axes,[0 90 0 max(handles.Results.Totals.scatpts)]); axis(handles.scattering_axes,'auto y');
            set(handles.scattering_axes,'XTick',[0,30,60,90]); hold(handles.scattering_axes,'on');
            xlabel(handles.scattering_axes,'\theta','FontName','Verdana','FontSize',8)
            grid(handles.scattering_axes,'on'); ylabel(handles.scattering_axes,'Scattering pts','FontSize',7); 
            set(handles.legend_text,'String',''); legend(handles.scattering_axes,'results','Location','NorthEastOutside');
        else % Monte Carlo mode
            if get(handles.plotslope2D_togglebutton,'Value')
                plot(handles.scattering_axes,handles.Results.Slopes,handles.Results.Totals.scatpts(:,n),'-*');
                axis(handles.scattering_axes,[0 max(handles.Results.Slopes) 0 max(max(handles.Results.Totals.scatpts(:,n)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTickMode','auto'); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'slope','FontSize',7)
                set(handles.legend_text,'String','Theta');
            else % Monte Carlo mode
                plot(handles.scattering_axes,handles.Results.Thetas,handles.Results.Totals.scatpts(n,:),'-*');
                axis(handles.scattering_axes,[0 90 0 max(max(handles.Results.Totals.scatpts(n,:)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTick',[0,30,60,90]); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'\theta','FontName','Verdana','FontSize',8)
                set(handles.legend_text,'String','slope');
            end
            legendlista = get(handles.plotvar2D_listbox,'String');
            grid(handles.scattering_axes,'on'); ylabel(handles.scattering_axes,'Scattering pts','FontSize',7); legend(handles.scattering_axes,legendlista(get(handles.plotvar2D_listbox,'Value'),:),'Location','NorthEastOutside');
        end
        
        
        % plot amount of shadowing
        cla(handles.shadowing_axes);
        set(handles.shadowing_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1 % Mode 1
            plot(handles.shadowing_axes,handles.Results.Thetas,handles.Results.Totals.shadowing,'-*');
            axis(handles.shadowing_axes,[0 max(handles.Results.Thetas) 0 1]); set(handles.shadowing_axes,'XTickMode','auto'); hold(handles.shadowing_axes,'on');
            xlabel(handles.shadowing_axes,'\theta','FontName','Verdana','FontSize',8)
        else % Monte Carlo mode
            if get(handles.plotslope2D_togglebutton,'Value')
                plot(handles.shadowing_axes,handles.Results.Slopes,handles.Results.Totals.shadowing(:,n),'-*');
                axis(handles.shadowing_axes,[0 max(handles.Results.Slopes) 0 1]); set(handles.shadowing_axes,'XTickMode','auto'); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'slope','FontSize',7)
            else
                plot(handles.shadowing_axes,handles.Results.Thetas,handles.Results.Totals.shadowing(n,:),'-*');
                axis(handles.shadowing_axes,[0 90 0 1]); set(handles.shadowing_axes,'XTick',[0,30,60,90]); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'\theta','FontName','Verdana','FontSize',8)
            end
        end
        grid(handles.shadowing_axes,'on'); ylabel(handles.shadowing_axes,'Shadowing','FontSize',7)
        
        % plot amount of warning signals
        cla(handles.warnings_axes);
        set(handles.warnings_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1 % Mode 1
            plot(handles.warnings_axes,handles.Results.Thetas,handles.Results.Totals.warnings,'-*');
            axis(handles.warnings_axes,[0 max(handles.Results.Thetas) 0 1]); set(handles.warnings_axes,'XTickMode','auto'); hold(handles.warnings_axes,'on');
            xlabel(handles.warnings_axes,'\theta','FontName','Verdana','FontSize',8)
        else % Monte Carlo mode
            if get(handles.plotslope2D_togglebutton,'Value')
                plot(handles.warnings_axes,handles.Results.Slopes,handles.Results.Totals.warnings(:,n),'-*');
                axis(handles.warnings_axes,[0 max(handles.Results.Slopes) 0 1]); set(handles.warnings_axes,'XTickMode','auto'); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'slope','FontSize',7)
            else
                plot(handles.warnings_axes,handles.Results.Thetas,handles.Results.Totals.warnings(n,:),'-*');
                axis(handles.warnings_axes,[0 90 0 1]); set(handles.warnings_axes,'XTick',[0,30,60,90]); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'\theta','FontName','Verdana','FontSize',8)
            end
        end
        grid(handles.warnings_axes,'on'); ylabel(handles.warnings_axes,'Warning level','FontSize',7)
        
        % plot BRDF
        cla(handles.brdftotal_axes);
        thetaindex = get(handles.brdftheta_popupmenu,'Value');
        if handles.Results.Mode == 1 % Mode 1
            plot(handles.brdftotal_axes,-90:1:90,squeeze(sum(handles.Results.Totals.brdf(thetaindex,:,:),2)),'-k'); hold(handles.brdftotal_axes,'on');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(handles.Results.Totals.brdf(thetaindex,1,:)),'-b'); hold(handles.brdftotal_axes,'on');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(handles.Results.Totals.brdf(thetaindex,2,:)),'-g'); hold(handles.brdftotal_axes,'on');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(handles.Results.Totals.brdf(thetaindex,3,:)),'-r'); hold(handles.brdftotal_axes,'on');
            grid(handles.brdftotal_axes,'on'); axis(handles.brdftotal_axes,[-90 90 0 max(sum(handles.Results.Totals.brdf(thetaindex,:,5:end-5),2))]);
        else % Monte Carlo mode
            slopeindex = get(handles.brdfslope_popupmenu,'Value');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(sum(handles.Results.Totals.brdf(slopeindex,thetaindex,:,:),3)),'-k'); hold(handles.brdftotal_axes,'on');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(handles.Results.Totals.brdf(slopeindex,thetaindex,1,:)),'-b'); hold(handles.brdftotal_axes,'on');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(handles.Results.Totals.brdf(slopeindex,thetaindex,2,:)),'-g'); hold(handles.brdftotal_axes,'on');
            plot(handles.brdftotal_axes,-90:1:90,squeeze(handles.Results.Totals.brdf(slopeindex,thetaindex,3,:)),'-r'); hold(handles.brdftotal_axes,'on');
            grid(handles.brdftotal_axes,'on'); axis(handles.brdftotal_axes,[-90 90 0 max(sum(handles.Results.Totals.brdf(slopeindex,thetaindex,:,5:end-5),3))]);
        end
        set(handles.brdftotal_axes,'XTick',[-90,-60,-30,0,30,60,90]); legend(handles.brdftotal_axes,'total','1st','2nd','3rd','Location','EastOutside');
        xlabel(handles.brdftotal_axes,'\theta','FontName','Verdana','FontSize',8); ylabel(handles.brdftotal_axes,'BRDF','FontSize',7)

else % 3D scattering

    set(handles.plotoptions2D_panel,'Visible','off');
    set(handles.brdfplot_panel,'Visible','on');
    if handles.Results.Mode == 1 % Mode 1
        set(handles.plotslope3D_togglebutton,'Enable','off');
        set(handles.plotvar3DB_listbox,'Enable','off');
        n = get(handles.plotvar3DA_listbox,'Value');
    else % Monte Carlo mode
        set(handles.plotslope3D_togglebutton,'Enable','on');
        set(handles.plotvar3DB_listbox,'Enable','on');
        n = get(handles.plotvar3DA_listbox,'Value');
        m = get(handles.plotvar3DB_listbox,'Value');
    end
    set(handles.plotoptions3D_panel,'Visible','on');
    
    % plot directional-hemispherical reflectance (DHR)
    cla(handles.DHR_axes);
    set(handles.DHR_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1
            if get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.DHR_axes,handles.Results.Thetas,handles.Results.Totals.DHR(:,n),'-*');
                axis(handles.DHR_axes,[0 90 0 1]); set(handles.DHR_axes,'XTick',[0,30,60,90]); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'\theta','FontSize',8)
            else
                plot(handles.DHR_axes,handles.Results.Phis,handles.Results.Totals.DHR(n,:),'-*');
                axis(handles.DHR_axes,[0 360 0 1]); set(handles.DHR_axes,'XTick',[0,90,180,270,360]); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'\phi','FontSize',8)
            end
        else
            if get(handles.plotslope3D_togglebutton,'Value')
                plot(handles.DHR_axes,handles.Results.Slopes,handles.Results.Totals.DHR(:,n,m),'-*');
                axis(handles.DHR_axes,[0 max(handles.Results.Slopes) 0 1]); set(handles.DHR_axes,'XTickMode','auto'); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'slope','FontSize',7)
            elseif get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.DHR_axes,handles.Results.Thetas,handles.Results.Totals.DHR(n,:,m),'-*');
                axis(handles.DHR_axes,[0 90 0 1]); set(handles.DHR_axes,'XTick',[0,30,60,90]); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'\theta','FontSize',8)
            else
                plot(handles.DHR_axes,handles.Results.Phis,handles.Results.Totals.DHR(n,:,m),'-*');
                axis(handles.DHR_axes,[0 360 0 1]); set(handles.DHR_axes,'XTick',[0,90,180,270,360]); hold(handles.DHR_axes,'on');
                xlabel(handles.DHR_axes,'\phi','FontSize',8)
            end
        end
        grid(handles.DHR_axes,'on'); ylabel(handles.DHR_axes,'DHR','FontSize',7)
        
        % plot mean number of scattering points
        cla(handles.scattering_axes);
        set(handles.scattering_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1
            if get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.scattering_axes,handles.Results.Thetas,handles.Results.Totals.scatpts(:,n),'-*');
                axis(handles.scattering_axes,[0 90 0 max(max(handles.Results.Totals.scatpts(:,n)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTick',[0,30,60,90]); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'\theta','FontName','Verdana','FontSize',8)
                set(handles.legend_text,'String','');
            else
                plot(handles.scattering_axes,handles.Results.Phis,handles.Results.Totals.scatpts(n,:),'-*');
                axis(handles.scattering_axes,[0 360 0 max(max(handles.Results.Totals.scatpts(n,:)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTick',[0,90,180,270,360]); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'\phi','FontName','Verdana','FontSize',8)
                set(handles.legend_text,'String','');
            end
            legendlista = get(handles.plotvar3DA_listbox,'String');
            grid(handles.scattering_axes,'on'); ylabel(handles.scattering_axes,'Scattering pts','FontSize',7); legend(handles.scattering_axes,legendlista(get(handles.plotvar3DA_listbox,'Value'),:),'Location','NorthEastOutside');
        else
            if get(handles.plotslope3D_togglebutton,'Value')
                plot(handles.scattering_axes,handles.Results.Slopes,handles.Results.Totals.scatpts(:,n,m),'-*');
                axis(handles.scattering_axes,[0 max(handles.Results.Slopes) 0 max(max(handles.Results.Totals.scatpts(:,n)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTickMode','auto'); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'slope','FontSize',7)
                set(handles.legend_text,'String','Theta');
            elseif get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.scattering_axes,handles.Results.Thetas,handles.Results.Totals.scatpts(n,:,m),'-*');
                axis(handles.scattering_axes,[0 90 0 max(max(handles.Results.Totals.scatpts(n,:)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTick',[0,30,60,90]); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'\theta','FontName','Verdana','FontSize',8)
                set(handles.legend_text,'String','slope');
            else
                plot(handles.scattering_axes,handles.Results.Phis,handles.Results.Totals.scatpts(n,:,m),'-*');
                axis(handles.scattering_axes,[0 360 0 max(max(handles.Results.Totals.scatpts(n,:)))]); axis(handles.scattering_axes,'auto y');
                set(handles.scattering_axes,'XTick',[0,90,180,270,360]); hold(handles.scattering_axes,'on');
                xlabel(handles.scattering_axes,'\phi','FontName','Verdana','FontSize',8)
                set(handles.legend_text,'String','slope');
            end
            legendlista = get(handles.plotvar3DA_listbox,'String');
            grid(handles.scattering_axes,'on'); ylabel(handles.scattering_axes,'Scattering pts','FontSize',7); legend(handles.scattering_axes,legendlista(get(handles.plotvar3DA_listbox,'Value'),:),'Location','NorthEastOutside');
        end
        
        % plot amount of shadowing
        cla(handles.shadowing_axes);
        set(handles.shadowing_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1
            if get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.shadowing_axes,handles.Results.Thetas,handles.Results.Totals.shadowing(:,n),'-*');
                axis(handles.shadowing_axes,[0 90 0 1]); set(handles.shadowing_axes,'XTick',[0,30,60,90]); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'\theta','FontName','Verdana','FontSize',8)
            else
                plot(handles.shadowing_axes,handles.Results.Phis,handles.Results.Totals.shadowing(n,:),'-*');
                axis(handles.shadowing_axes,[0 360 0 1]); set(handles.shadowing_axes,'XTick',[0,90,180,270,360]); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'\phi','FontName','Verdana','FontSize',8)
            end
        else
            if get(handles.plotslope3D_togglebutton,'Value')
                plot(handles.shadowing_axes,handles.Results.Slopes,handles.Results.Totals.shadowing(:,n,m),'-*');
                axis(handles.shadowing_axes,[0 max(handles.Results.Slopes) 0 1]); set(handles.shadowing_axes,'XTickMode','auto'); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'slope','FontSize',7)
            elseif get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.shadowing_axes,handles.Results.Thetas,handles.Results.Totals.shadowing(n,:,m),'-*');
                axis(handles.shadowing_axes,[0 90 0 1]); set(handles.shadowing_axes,'XTick',[0,30,60,90]); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'\theta','FontName','Verdana','FontSize',8)
            else
                plot(handles.shadowing_axes,handles.Results.Phis,handles.Results.Totals.shadowing(n,:,m),'-*');
                axis(handles.shadowing_axes,[0 360 0 1]); set(handles.shadowing_axes,'XTick',[0,90,180,270,360]); hold(handles.shadowing_axes,'on');
                xlabel(handles.shadowing_axes,'\phi','FontName','Verdana','FontSize',8)
            end
        end
        grid(handles.shadowing_axes,'on'); ylabel(handles.shadowing_axes,'Shadowing','FontSize',7)
        
        % plot amount of warning signals
        cla(handles.warnings_axes);
        set(handles.warnings_axes,'ColorOrder',[0 0 1;0 1 0;1 0 0;0 1 1;1 0 1;1 1 0],...
            'LineStyleOrder','-|--|-.|:','NextPlot','Add');
        if handles.Results.Mode == 1
            if get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.warnings_axes,handles.Results.Thetas,handles.Results.Totals.warnings(:,n),'-*');
                axis(handles.warnings_axes,[0 90 0 1]); set(handles.warnings_axes,'XTick',[0,30,60,90]); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'\theta','FontName','Verdana','FontSize',8)
            else
                plot(handles.warnings_axes,handles.Results.Phis,handles.Results.Totals.warnings(n,:),'-*');
                axis(handles.warnings_axes,[0 360 0 1]); set(handles.warnings_axes,'XTick',[0,90,180,270,360]); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'\phi','FontName','Verdana','FontSize',8)
            end
        else
            if get(handles.plotslope3D_togglebutton,'Value')
                plot(handles.warnings_axes,handles.Results.Slopes,handles.Results.Totals.warnings(:,n,m),'-*');
                axis(handles.warnings_axes,[0 max(handles.Results.Slopes) 0 1]); set(handles.warnings_axes,'XTickMode','auto'); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'slope','FontSize',7)
            elseif get(handles.plottheta3D_togglebutton,'Value')
                plot(handles.warnings_axes,handles.Results.Thetas,handles.Results.Totals.warnings(n,:,m),'-*');
                axis(handles.warnings_axes,[0 90 0 1]); set(handles.warnings_axes,'XTick',[0,30,60,90]); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'\theta','FontName','Verdana','FontSize',8)
            else
                plot(handles.warnings_axes,handles.Results.Phis,handles.Results.Totals.warnings(n,:,m),'-*');
                axis(handles.warnings_axes,[0 360 0 1]); set(handles.warnings_axes,'XTick',[0,90,180,270,360]); hold(handles.warnings_axes,'on');
                xlabel(handles.warnings_axes,'\phi','FontName','Verdana','FontSize',8)
            end
        end
        grid(handles.warnings_axes,'on'); ylabel(handles.warnings_axes,'Warning level','FontSize',7)
        
        % plot BRDF
        cla(handles.brdftotal_axes);
        if handles.Results.Mode == 1
            brdf(1,:,:) = handles.Results.Totals.brdf(get(handles.brdftheta_popupmenu,'Value'),get(handles.brdfphi_popupmenu,'Value'),1,:,:);
            brdf(2,:,:) = handles.Results.Totals.brdf(get(handles.brdftheta_popupmenu,'Value'),get(handles.brdfphi_popupmenu,'Value'),2,:,:);
            brdf(3,:,:) = handles.Results.Totals.brdf(get(handles.brdftheta_popupmenu,'Value'),get(handles.brdfphi_popupmenu,'Value'),3,:,:);
        else
            brdf(1,:,:) = handles.Results.Totals.brdf(get(handles.brdfslope_popupmenu,'Value'),get(handles.brdftheta_popupmenu,'Value'),get(handles.brdfphi_popupmenu,'Value'),1,:,:);
            brdf(2,:,:) = handles.Results.Totals.brdf(get(handles.brdfslope_popupmenu,'Value'),get(handles.brdftheta_popupmenu,'Value'),get(handles.brdfphi_popupmenu,'Value'),2,:,:);
            brdf(3,:,:) = handles.Results.Totals.brdf(get(handles.brdfslope_popupmenu,'Value'),get(handles.brdftheta_popupmenu,'Value'),get(handles.brdfphi_popupmenu,'Value'),3,:,:);
        end
        
        if get(handles.brdf2D_togglebutton,'Value')
            
            contents = cellstr(get(handles.phi2_popupmenu,'String'));
            phi2 = str2double(contents{get(handles.phi2_popupmenu,'Value')});
            if phi2 >= 0 && phi2 < 180
                phi = phi2 + 180;
            else phi = phi2 - 180;
            end
                         
            if nnz(brdf) > 0 % non-zero elements exist
                if phi <= 5
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:phi2),3) + sum(brdf(:,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(sum(brdf(:,1,phi2-5:phi2),3) + sum(brdf(:,1,phi2+1:phi2+5),3),1) + sum(sum(brdf(:,1,phi+360-5:360),3) + sum(brdf(:,1,1:phi+5),3),1)...
                        fliplr(sum(sum(brdf(:,2:91,phi+360-5:360),3) + sum(brdf(:,2:91,1:phi+5),3),1))]),'-k'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(brdf(1,2:91,phi2-5:phi2),3) +sum(brdf(1,2:91,phi2+1:phi2+5),3)) ...
                        sum(brdf(1,1,phi2-5:phi2),3) + sum(brdf(1,1,phi2+1:phi2+5),3) + sum(brdf(1,1,phi+360-5:360),3) + sum(brdf(1,1,1:phi+5),3)...
                        fliplr(sum(brdf(1,2:91,phi+360-5:360),3) + sum(brdf(1,2:91,1:phi+5),3))]),'-b'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(brdf(2,2:91,phi2-5:phi2),3) +sum(brdf(2,2:91,phi2+1:phi2+5),3)) ...
                        sum(brdf(2,1,phi2-5:phi2),3) + sum(brdf(2,1,phi2+1:phi2+5),3) + sum(brdf(2,1,phi+360-5:360),3) + sum(brdf(2,1,1:phi+5),3)...
                        fliplr(sum(brdf(2,2:91,phi+360-5:360),3) + sum(brdf(2,2:91,1:phi+5),3))]),'-g'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(brdf(3,2:91,phi2-5:phi2),3) +sum(brdf(3,2:91,phi2+1:phi2+5),3)) ...
                        sum(brdf(3,1,phi2-5:phi2),3) + sum(brdf(3,1,phi2+1:phi2+5),3) + sum(brdf(3,1,phi+360-5:360),3) + sum(brdf(3,1,1:phi+5),3)...
                        fliplr(sum(brdf(3,2:91,phi+360-5:360),3) + sum(brdf(3,2:91,1:phi+5),3))]),'-r'); hold(handles.brdftotal_axes,'on');
                elseif phi >= 356
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:phi2),3) + sum(brdf(:,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(sum(brdf(:,1,phi2-5:phi2),3) + sum(brdf(:,1,phi2+1:phi2+5),3),1) + sum(sum(brdf(:,1,phi-5:360),3) + sum(brdf(:,1,1:10-(360-(phi-5))),3),1)...
                        fliplr(sum(sum(brdf(:,2:91,phi-5:360),3) + sum(brdf(:,2:91,10-(360-(phi-5))),3),1))]),'-k'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(1,2:91,phi2-5:phi2),3) + sum(brdf(1,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(brdf(1,1,phi2-5:phi2),3) + sum(brdf(1,1,phi2+1:phi2+5),3) + sum(brdf(1,1,phi-5:360),3) + sum(brdf(1,1,1:10-(360-(phi-5))),3)...
                        fliplr(sum(sum(brdf(1,2:91,phi-5:360),3) + sum(brdf(1,2:91,10-(360-(phi-5))),3),1))]),'-b'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(2,2:91,phi2-5:phi2),3) + sum(brdf(2,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(brdf(2,1,phi2-5:phi2),3) + sum(brdf(2,1,phi2+1:phi2+5),3) + sum(brdf(2,1,phi-5:360),3) + sum(brdf(2,1,1:10-(360-(phi-5))),3)...
                        fliplr(sum(sum(brdf(2,2:91,phi-5:360),3) + sum(brdf(2,2:91,10-(360-(phi-5))),3),1))]),'-g'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(3,2:91,phi2-5:phi2),3) + sum(brdf(3,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(brdf(3,1,phi2-5:phi2),3) + sum(brdf(3,1,phi2+1:phi2+5),3) + sum(brdf(3,1,phi-5:360),3) + sum(brdf(3,1,1:10-(360-(phi-5))),3)...
                        fliplr(sum(sum(brdf(3,2:91,phi-5:360),3) + sum(brdf(3,2:91,10-(360-(phi-5))),3),1))]),'-r'); hold(handles.brdftotal_axes,'on');
                elseif phi2 <= 5
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2+360-5:360),3) + sum(brdf(:,2:91,1:phi2+5),3),1)) ...
                        sum(sum(brdf(:,1,phi2+360-5:360),3) + sum(brdf(:,1,1:phi2+5),3),1) + sum(sum(brdf(:,1,phi-5:phi),3) + sum(brdf(:,1,phi+1:phi+5),3),1)...
                        fliplr(sum(sum(brdf(:,2:91,phi-5:phi),3) + sum(brdf(:,2:91,phi+1:phi+5),3),1))]),'-k'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(brdf(1,2:91,phi2+360-5:360),3) +sum(brdf(1,2:91,1:phi2+5),3)) ...
                        sum(brdf(1,1,phi2+360-5:360),3) + sum(brdf(1,1,1:phi2+5),3) + sum(brdf(1,1,phi-5:phi),3) + sum(brdf(1,1,phi+1:phi+5),3)...
                        fliplr(sum(brdf(1,2:91,phi-5:phi),3) + sum(brdf(1,2:91,phi+1:phi+5),3))]),'-b'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(brdf(2,2:91,phi2+360-5:360),3) +sum(brdf(2,2:91,1:phi2+5),3)) ...
                        sum(brdf(2,1,phi2+360-5:360),3) + sum(brdf(2,1,1:phi2+5),3) + sum(brdf(2,1,phi-5:phi),3) + sum(brdf(2,1,phi+1:phi+5),3)...
                        fliplr(sum(brdf(2,2:91,phi-5:phi),3) + sum(brdf(2,2:91,phi+1:phi+5),3))]),'-g'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(brdf(3,2:91,phi2+360-5:360),3) +sum(brdf(3,2:91,1:phi2+5),3)) ...
                        sum(brdf(3,1,phi2+360-5:360),3) + sum(brdf(3,1,1:phi2+5),3) + sum(brdf(3,1,phi-5:phi),3) + sum(brdf(3,1,phi+1:phi+5),3)...
                        fliplr(sum(brdf(3,2:91,phi-5:phi),3) + sum(brdf(3,2:91,phi+1:phi+5),3))]),'-r'); hold(handles.brdftotal_axes,'on');
                elseif phi2 >= 356
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:360),3) + sum(brdf(:,2:91,10-(360-(phi2-5))),3),1)) ...
                        sum(sum(brdf(:,1,phi2-5:360),3) + sum(brdf(:,1,10-(360-(phi2-5))),3),1) + sum(sum(brdf(:,1,phi-5:phi),3) + sum(brdf(:,1,phi+1:phi+5),3),1)...
                        fliplr(sum(sum(brdf(:,2:91,phi-5:phi),3) + sum(brdf(:,2:91,phi+1:phi+5),3),1))]),'-k'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(1,2:91,phi2-5:360),3) + sum(brdf(1,2:91,10-(360-(phi2-5))),3),1)) ...
                        sum(brdf(1,1,phi2-5:360),3) + sum(brdf(1,1,10-(360-(phi2-5))),3) + sum(brdf(1,1,phi-5:phi),3) + sum(brdf(1,1,phi+1:phi+5),3)...
                        fliplr(sum(sum(brdf(1,2:91,phi-5:phi),3) + sum(brdf(1,2:91,phi+1:phi+5),3),1))]),'-b'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(2,2:91,phi2-5:360),3) + sum(brdf(2,2:91,10-(360-(phi2-5))),3),1)) ...
                        sum(brdf(2,1,phi2-5:360),3) + sum(brdf(2,1,10-(360-(phi2-5))),3) + sum(brdf(2,1,phi-5:phi),3) + sum(brdf(2,1,phi+1:phi+5),3)...
                        fliplr(sum(sum(brdf(2,2:91,phi-5:phi),3) + sum(brdf(2,2:91,phi+1:phi+5),3),1))]),'-g'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(3,2:91,phi2-5:360),3) + sum(brdf(3,2:91,10-(360-(phi2-5))),3),1)) ...
                        sum(brdf(3,1,phi2-5:360),3) + sum(brdf(3,1,10-(360-(phi2-5))),3) + sum(brdf(3,1,phi-5:phi),3) + sum(brdf(3,1,phi+1:phi+5),3)...
                        fliplr(sum(sum(brdf(3,2:91,phi-5:phi),3) + sum(brdf(3,2:91,phi+1:phi+5),3),1))]),'-r'); hold(handles.brdftotal_axes,'on');
                else
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(:,2:91,phi2-5:phi2),3) + sum(brdf(:,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(sum(brdf(:,1,phi2-5:phi2),3) + sum(brdf(:,1,phi2+1:phi2+5),3),1) +  sum(sum(brdf(:,1,phi-5:phi),3) + sum(brdf(:,1,phi+1:phi+5),3),1) ...
                        fliplr(sum(sum(brdf(:,2:91,phi-5:phi),3) + sum(brdf(:,2:91,phi+1:phi+5),3),1))]),'-k'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(1,2:91,phi2-5:phi2),3) + sum(brdf(1,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(brdf(1,1,phi2-5:phi2),3) + sum(brdf(1,1,phi2+1:phi2+5),3) +  sum(brdf(1,1,phi-5:phi),3) + sum(brdf(1,1,phi+1:phi+5),3) ...
                        fliplr(sum(sum(brdf(1,2:91,phi-5:phi),3) + sum(brdf(1,2:91,phi+1:phi+5),3),1))]),'-b'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(2,2:91,phi2-5:phi2),3) + sum(brdf(2,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(brdf(2,1,phi2-5:phi2),3) + sum(brdf(2,1,phi2+1:phi2+5),3) +  sum(brdf(2,1,phi-5:phi),3) + sum(brdf(2,1,phi+1:phi+5),3) ...
                        fliplr(sum(sum(brdf(2,2:91,phi-5:phi),3) + sum(brdf(2,2:91,phi+1:phi+5),3),1))]),'-g'); hold(handles.brdftotal_axes,'on');
                    plot(handles.brdftotal_axes,-90:1:90,squeeze([fliplr(sum(sum(brdf(3,2:91,phi2-5:phi2),3) + sum(brdf(3,2:91,phi2+1:phi2+5),3),1)) ...
                        sum(brdf(3,1,phi2-5:phi2),3) + sum(brdf(3,1,phi2+1:phi2+5),3) +  sum(brdf(3,1,phi-5:phi),3) + sum(brdf(3,1,phi+1:phi+5),3) ...
                        fliplr(sum(sum(brdf(3,2:91,phi-5:phi),3) + sum(brdf(3,2:91,phi+1:phi+5),3),1))]),'-r'); hold(handles.brdftotal_axes,'on');
                end
                hold(handles.brdftotal_axes,'on'); legend(handles.brdftotal_axes,'tot','1st','2nd','3rd','Location','EastOutside'); view(handles.brdftotal_axes,2)
                grid(handles.brdftotal_axes,'on'); axis(handles.brdftotal_axes,[-90 90 0 1]); axis(handles.brdftotal_axes,'auto y'); set(handles.brdftotal_axes,'XTick',[-90,-45,0,45,90]); set(handles.brdftotal_axes,'YTickMode','auto');
                xlabel(handles.brdftotal_axes,'\theta','FontName','Verdana','FontSize',8); ylabel(handles.brdftotal_axes,'BRDF','FontSize',7)
                view(handles.brdftotal_axes,2)
            end
            
            
        else
            cla(handles.brdftotal_axes);
            
            brdftot = reshape(squeeze(sum(brdf)),1,91*360);
            theta = repmat(1:91,1,360);
            phi = repmat(1:360,1,91);
            [X,Y,Z] = sph2cart(theta,phi,brdftot);
            [phi theta] = meshgrid(0:359,0:90);
            mesh(handles.brdftotal_axes,squeeze(sum(brdf))); axis(handles.brdftotal_axes,[0 360 0 90 0 max(max(squeeze(sum(brdf))))])
            set(handles.brdftotal_axes,'XTick',[0,90,180,270,360]); set(handles.brdftotal_axes,'YTick',[0,30,60,90]);
            xlabel(handles.brdftotal_axes,'\phi','FontName','Verdana','FontSize',10); ylabel(handles.brdftotal_axes,'\theta','FontName','Verdana','FontSize',10); zlabel(handles.brdftotal_axes,'BRDF');
            view(handles.brdftotal_axes,[60,20])
        end
end



function realisations_edit_Callback(hObject, eventdata, handles)
% hObject    handle to realisations_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of realisations_edit as text
%        str2double(get(hObject,'String')) returns contents of realisations_edit as a double


% --- Executes during object creation, after setting all properties.
function realisations_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to realisations_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function theta_edit_Callback(hObject, eventdata, handles)
% hObject    handle to theta_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of theta_edit as text
%        str2double(get(hObject,'String')) returns contents of theta_edit as a double


% --- Executes during object creation, after setting all properties.
function theta_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to theta_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function rays_edit_Callback(hObject, eventdata, handles)
% hObject    handle to rays_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of rays_edit as text
%        str2double(get(hObject,'String')) returns contents of rays_edit as a double


% --- Executes during object creation, after setting all properties.
function rays_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rays_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function n1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to n1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n1_edit as text
%        str2double(get(hObject,'String')) returns contents of n1_edit as a double


% --- Executes during object creation, after setting all properties.
function n1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function k1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to k1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of k1_edit as text
%        str2double(get(hObject,'String')) returns contents of k1_edit as a double


% --- Executes during object creation, after setting all properties.
function k1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function n2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to n2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n2_edit as text
%        str2double(get(hObject,'String')) returns contents of n2_edit as a double


% --- Executes during object creation, after setting all properties.
function n2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function k2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to k2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of k2_edit as text
%        str2double(get(hObject,'String')) returns contents of k2_edit as a double


% --- Executes during object creation, after setting all properties.
function k2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in beamdist_popupmenu.
function beamdist_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to beamdist_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns beamdist_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from beamdist_popupmenu


% --- Executes during object creation, after setting all properties.
function beamdist_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to beamdist_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function beamradius_edit_Callback(hObject, eventdata, handles)
% hObject    handle to beamradius_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of beamradius_edit as text
%        str2double(get(hObject,'String')) returns contents of beamradius_edit as a double


% --- Executes during object creation, after setting all properties.
function beamradius_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to beamradius_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function phi_edit_Callback(hObject, eventdata, handles)
% hObject    handle to phi_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of phi_edit as text
%        str2double(get(hObject,'String')) returns contents of phi_edit as a double


% --- Executes during object creation, after setting all properties.
function phi_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to phi_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in noniso_checkbox.
function noniso_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to noniso_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of noniso_checkbox
if get(hObject,'Value') % non-isotropic 2D surface
    set(handles.cliso_text,'Visible','off');
    set(handles.clength_edit,'Visible','off');
    set(handles.clnoniso_text,'Visible','on');
    set(handles.clengthx_edit,'Visible','on');
    set(handles.clengthy_edit,'Visible','on');
    set(handles.x_text,'Visible','on');
    set(handles.y_text,'Visible','on');
else % isotropic 2D surface
    set(handles.clnoniso_text,'Visible','off');
    set(handles.clengthx_edit,'Visible','off');
    set(handles.clengthy_edit,'Visible','off');
    set(handles.x_text,'Visible','off');
    set(handles.y_text,'Visible','off');
    set(handles.cliso_text,'Visible','on');
    set(handles.clength_edit,'Visible','on'); 
end

% --- Executes on selection change in acf_popupmenu.
function acf_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to acf_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns acf_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from acf_popupmenu


% --- Executes during object creation, after setting all properties.
function acf_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to acf_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in hdf_popupmenu.
function hdf_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to hdf_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns hdf_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from hdf_popupmenu


% --- Executes during object creation, after setting all properties.
function hdf_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hdf_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function surfpts_edit_Callback(hObject, eventdata, handles)
% hObject    handle to surfpts_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of surfpts_edit as text
%        str2double(get(hObject,'String')) returns contents of surfpts_edit as a double


% --- Executes during object creation, after setting all properties.
function surfpts_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to surfpts_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function surflength_edit_Callback(hObject, eventdata, handles)
% hObject    handle to surflength_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of surflength_edit as text
%        str2double(get(hObject,'String')) returns contents of surflength_edit as a double


% --- Executes during object creation, after setting all properties.
function surflength_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to surflength_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function rmsheight_edit_Callback(hObject, eventdata, handles)
% hObject    handle to rmsheight_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of rmsheight_edit as text
%        str2double(get(hObject,'String')) returns contents of rmsheight_edit as a double


% --- Executes during object creation, after setting all properties.
function rmsheight_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rmsheight_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function clength_edit_Callback(hObject, eventdata, handles)
% hObject    handle to clength_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of clength_edit as text
%        str2double(get(hObject,'String')) returns contents of clength_edit as a double


% --- Executes during object creation, after setting all properties.
function clength_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clength_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function clengthx_edit_Callback(hObject, eventdata, handles)
% hObject    handle to clengthx_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of clengthx_edit as text
%        str2double(get(hObject,'String')) returns contents of clengthx_edit as a double


% --- Executes during object creation, after setting all properties.
function clengthx_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clengthx_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function clengthy_edit_Callback(hObject, eventdata, handles)
% hObject    handle to clengthy_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of clengthy_edit as text
%        str2double(get(hObject,'String')) returns contents of clengthy_edit as a double


% --- Executes during object creation, after setting all properties.
function clengthy_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clengthy_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in addsurf_pushbutton.
function addsurf_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to addsurf_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[fileName,pathName] = uigetfile('*.mat','Select surface(s)', 'MultiSelect', 'on',handles.workdir);

if ischar(fileName)
    fileName = {fileName};
end
if ~isequal(fileName,0)
    currdir = pwd;
    cd(pathName);
    
    listItems = get(handles.surf_listbox,'String');
    listValue = get(handles.surf_listbox,'Value');
    
    nFiles = length(fileName);
    surfcheck = zeros(1,nFiles);
    n = 1;
    for fnI = 1:nFiles
        fileNames{fnI} = fullfile(pathName, fileName{fnI});
        surf = load(fullfile(pathName,fileName{fnI}));
        [check dim] = checksurf(surf);
        if ~check
            surfcheck(fnI) = 0;
        else
            surfcheck(fnI) = 1;
            if dim == 1
                addfiles{n} = cat(2,fileNames{fnI},' (1D)');
            else
                addfiles{n} = cat(2,fileNames{fnI},' (2D)');
            end
            dimensions(n) = dim;
        end  
        n = n + 1;
    end
    if nnz(surfcheck) > 0
        if isempty(listItems)
            handles.surf_listbox_dim = dimensions(1);
        end
        if ~isequal(dimensions,ones(size(dimensions)))
            if ~isequal(dimensions,ones(size(dimensions))*2) || dimensions(1) ~= handles.surf_listbox_dim
                errordlg('GOA can only run ray-tracing simulations on equidimensional surfaces!','Error!','modal');
                return
            end
        end
        set(handles.surf_listbox, 'String', [addfiles(:); listItems]);
        set(handles.surf_listbox, 'Value', 1);
        handles.surf_listbox_dim = dimensions(1);
        guidata(hObject, handles)
    end
    if nnz(surfcheck) ~= length(surfcheck)
        warning_str = 'The following files could not be added due to wrong format: ';
        found = find(surfcheck == 0);
        for m = found
            warning_str = cat(2,warning_str,fileName{m});
            if m == found(end)
                warning_str = cat(2,warning_str,'.');
            else
                warning_str = cat(2,warning_str,', ');
            end
        end
        warndlg(warning_str,'Warning!','modal');
    end
    
    cd(currdir); 
    
end

function [ok dim] = checksurf(surface)
ok = 0; dim = 0;
if isfield(surface,'x') && isfield(surface,'f')
    if isfield(surface,'y')
        if size(surface.y,1) == 1 && size(surface.y,2) > 1 && size(surface.y,2) == size(surface.x,2) && isreal(surface.y) && issorted(surface.y) && ...
                size(surface.f,1) == size(surface.y,2) && size(surface.f,2) == size(surface.y,2) && isreal(surface.f)
            dim = 2;
            ok = 1;
        else
            return
        end
    elseif size(surface.x,1) == 1 && size(surface.x,2) > 1 && isreal(surface.x) && issorted(surface.x) && ...
            size(surface.f,1) == size(surface.x,1) && size(surface.f,2) == size(surface.x,2) && isreal(surface.f)
        dim = 1;
        ok = 1;
    else
        return
    end
end

% --- Executes on selection change in surf_listbox.
function surf_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to surf_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns surf_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from surf_listbox


% --- Executes during object creation, after setting all properties.
function surf_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to surf_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in modeselection_panel.
function modeselection_panel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in modeselection_panel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if get(handles.mode1_togglebutton,'Value')
    set(handles.mode2_panel,'Visible','off');
    set(handles.mode1_panel,'Visible','on');
    set(handles.rays_edit,'Visible','on');
    set(handles.beamradius_edit,'Visible','on');
    set(handles.rays_edit,'String','');
    set(handles.beamradius_edit,'String','');
    set(handles.rays_text,'Visible','on');
    set(handles.br_text,'Visible','on');
else
    set(handles.mode1_panel,'Visible','off');
    set(handles.mode2_panel,'Visible','on');
    set(handles.rays_text,'Visible','off');
    set(handles.br_text,'Visible','off');
    set(handles.rays_edit,'String','');
    set(handles.beamradius_edit,'String','');
end


% --- Executes when selected object is changed in dimension_panel.
function dimension_panel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in dimension_panel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if get(handles.oned_togglebutton,'Value') % 1D button selected
    set(handles.noniso_checkbox,'Visible','off');
    set(handles.clnoniso_text,'Visible','off');
    set(handles.clengthx_edit,'Visible','off');
    set(handles.clengthy_edit,'Visible','off');
    set(handles.x_text,'Visible','off');
    set(handles.y_text,'Visible','off');
    set(handles.cliso_text,'Visible','on');
    set(handles.clength_edit,'Visible','on');  
    if ~isempty(get(handles.surfpts_edit,'String'))
       if eventdata.OldValue == handles.twod_togglebutton
            set(handles.surfpts_edit,'String','');
       end
    end
elseif get(handles.twod_togglebutton,'Value') % 2D button selected
    set(handles.noniso_checkbox,'Visible','on');
    if get(handles.noniso_checkbox,'Value')
        set(handles.cliso_text,'Visible','off');
        set(handles.clength_edit,'Visible','off');
        set(handles.clnoniso_text,'Visible','on');
        set(handles.clengthx_edit,'Visible','on');
        set(handles.clengthy_edit,'Visible','on');
        set(handles.x_text,'Visible','on');
        set(handles.y_text,'Visible','on');
    else
        set(handles.clnoniso_text,'Visible','off');
        set(handles.clengthx_edit,'Visible','off');
        set(handles.clengthy_edit,'Visible','off');
        set(handles.x_text,'Visible','off');
        set(handles.y_text,'Visible','off');
        set(handles.cliso_text,'Visible','on');
        set(handles.clength_edit,'Visible','on');
    end
    if ~isempty(get(handles.surfpts_edit,'String')) % to reduce out of memory problems
       if eventdata.OldValue == handles.oned_togglebutton
            set(handles.surfpts_edit,'String','');
       end
    end
end


% --- Executes on button press in removesurf_pushbutton.
function removesurf_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to removesurf_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
listItems = get(handles.surf_listbox,'String');
listValue = get(handles.surf_listbox,'Value');
listMask = ones(1,length(listItems));
listMask(listValue) = 0;
listItems = listItems(listMask==1);

% Update list
set(handles.surf_listbox, 'String', listItems);
set(handles.surf_listbox, 'Value', 1);


% --- Executes on button press in clearsurf_pushbutton.
function clearsurf_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to clearsurf_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.surf_listbox,'String', []);
set(handles.surf_listbox,'Value', 1);

% --- Executes on button press in loadconfig_pushbutton.
function loadconfig_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to loadconfig_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile('*.mat','Select Configuration File',handles.workdir);
if FileName ~= 0
    config = load(fullfile(PathName,FileName));
    
    if versioncheck(config.version, handles)
        
        if config.mode == 1 % mode 1
            set(handles.mode1_togglebutton,'Value',1);
            set(handles.mode2_panel,'Visible','off');
            set(handles.mode1_panel,'Visible','on'); 
            set(handles.surf_listbox,'String',config.surflist);
        elseif config.mode == 2 % mode 2
            set(handles.mode2_togglebutton,'Value',1);
            set(handles.realisations_edit,'String',config.surface.realisations);
            if config.surface.dim == 1
                set(handles.oned_togglebutton,'Value',1);
            elseif config.surface.dim == 2
                set(handles.twod_togglebutton,'Value',1);
            else
                errordlg('Wrong format!','modal');
                return
            end
            set(handles.hdf_popupmenu,'Value',config.surface.hdf);
            set(handles.acf_popupmenu,'Value',config.surface.acf);
            set(handles.noniso_checkbox,'Value',config.surface.noniso);
            noniso_checkbox_Callback(handles.noniso_checkbox, eventdata, handles);
            set(handles.surfpts_edit,'String',config.surface.surfpts);
            set(handles.surflength_edit,'String',config.surface.surflength);
            set(handles.rmsheight_edit,'String',config.surface.rmsheight);
            set(handles.clength_edit,'String',config.surface.clength);
            set(handles.clengthx_edit,'String',config.surface.clengthx);
            set(handles.clengthy_edit,'String',config.surface.clengthy);
            
            
            
            set(handles.mode1_panel,'Visible','off');
            set(handles.mode2_panel,'Visible','on');  
        else 
            errordlg('Wrong format!','modal');
            return
        end
        set(handles.theta_edit,'String',config.light.theta);
        set(handles.phi_edit,'String',config.light.phi);
        set(handles.rays_edit,'String',config.light.rays);
        set(handles.beamdist_popupmenu,'Value',config.light.beamdist);
        set(handles.beamradius_edit,'String',config.light.beamradius);
        
        set(handles.n1_edit,'String',config.material.n1);
        set(handles.k1_edit,'String',config.material.k1);
        set(handles.n2_edit,'String',config.material.n2);
        set(handles.k2_edit,'String',config.material.k2);
        
    else
        errordlg('Config file is too old for this version!','modal');
        return
    end
end
       



% --- Executes on button press in resetconfig_pushbutton.
function resetconfig_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to resetconfig_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.singleresults_panel,'Visible','off');
set(handles.totalresults_panel,'Visible','off');
set(handles.output_panel,'Visible','on');

if get(handles.mode1_togglebutton,'Value')
    set(handles.surf_listbox,'String','');
else
    set(handles.realisations_edit,'String','');
    set(handles.oned_togglebutton,'Value',1);
    set(handles.hdf_popupmenu,'Value',1);
    set(handles.acf_popupmenu,'Value',1);
    set(handles.noniso_checkbox,'Value',0);
    set(handles.surfpts_edit,'String','');
    set(handles.surflength_edit,'String','');
    set(handles.rmsheight_edit,'String','');
    set(handles.clength_edit,'String','');
    set(handles.clengthx_edit,'String','');
    set(handles.clengthy_edit,'String','');
end

set(handles.theta_edit,'String','');
set(handles.phi_edit,'String','');
set(handles.rays_edit,'String','');
set(handles.beamdist_popupmenu,'Value',1);
set(handles.beamradius_edit,'String','');

set(handles.n1_edit,'String','');
set(handles.k1_edit,'String','');
set(handles.n2_edit,'String','');
set(handles.k2_edit,'String','');

set(handles.mode2_togglebutton,'Value',1);
set(handles.mode1_panel,'Visible','off');
set(handles.mode2_panel,'Visible','on');  

if isfield(handles,'Results')
    handles = rmfield(handles,'Results');
end

guidata(hObject, handles)


% --- Executes on button press in saveconfig_pushbutton.
function saveconfig_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to saveconfig_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% minimum requirement for saving a configuration

if get(handles.mode1_togglebutton,'Value') % loaded surface
    contents = cellstr(get(handles.surf_listbox,'String'));
    if ~isempty(contents) || ...
            ~isempty(get(handles.theta_edit,'String')) || ~isempty(get(handles.phi_edit,'String')) || ...
            ~isempty(get(handles.rays_edit,'String')) || ~isempty(get(handles.beamradius_edit,'String')) || ...
            ~isempty(get(handles.n1_edit,'String')) || ~isempty(get(handles.k1_edit,'String')) || ...
            ~isempty(get(handles.n2_edit,'String')) || ~isempty(get(handles.k2_edit,'String'))
        
        config = buildconfig(handles);
        currdir = pwd;
        [fileName,pathName] = uiputfile('*.mat','Save Configuration As', cat(2,'configfile_',datestr(now,'yyyymmdd_HHMMSS')));
        save(fullfile(pathName,fileName),'-struct','config');
        cd(currdir);
    else
        errordlg('Error! No configuration to be saved!','modal');
        return
    end
elseif get(handles.mode2_togglebutton,'Value') % generated surface
    if ~isempty(get(handles.surfpts_edit,'String')) || ~isempty(get(handles.surflength_edit,'String')) || ...
            ~isempty(get(handles.rmsheight_edit,'String')) || ~isempty(get(handles.realisations_edit,'String')) || ...
            (~isempty(get(handles.clength_edit,'String')) || (~isempty(get(handles.clengthy_edit,'String')) || ~isempty(get(handles.clengthx_edit,'String')))) || ...
            ~isempty(get(handles.theta_edit,'String')) || ~isempty(get(handles.phi_edit,'String')) || ...
            ~isempty(get(handles.rays_edit,'String')) || ~isempty(get(handles.beamradius_edit,'String')) || ...
            ~isempty(get(handles.n1_edit,'String')) || ~isempty(get(handles.k1_edit,'String')) || ...
            ~isempty(get(handles.n2_edit,'String')) || ~isempty(get(handles.k2_edit,'String'))
        
        config = buildconfig(handles);
        [fileName,pathName] = uiputfile('*.mat','Save Configuration As', cat(2,'configfile_',datestr(now,'yyyymmdd_HHMMSS')));
        save(fullfile(pathName,fileName),'-struct','config');
    else
        errordlg('Error! No configuration to be saved!','modal');
        return
    end
end

% builds config file from GUI user selections
function config = buildconfig(handles)

% version
config.version = handles.version;

% selected mode
if get(handles.mode1_togglebutton,'Value')
    config.mode = 1;
    config.surflist = get(handles.surf_listbox,'String');
else
    config.mode = 2;
    config.surface.realisations = get(handles.realisations_edit,'String');
    if get(handles.oned_togglebutton,'Value')
        config.surface.dim = 1;
    else config.surface.dim = 2;  
    end

    config.surface.hdf = get(handles.hdf_popupmenu,'Value');
    config.surface.acf = get(handles.acf_popupmenu,'Value');
    config.surface.noniso = get(handles.noniso_checkbox,'Value');

    config.surface.surfpts = get(handles.surfpts_edit,'String');
    config.surface.surflength = get(handles.surflength_edit,'String');
    config.surface.rmsheight = get(handles.rmsheight_edit,'String');
    config.surface.clength = get(handles.clength_edit,'String');
    config.surface.clengthx = get(handles.clengthx_edit,'String');
    config.surface.clengthy = get(handles.clengthy_edit,'String');
end

config.light.theta = get(handles.theta_edit,'String');
config.light.phi = get(handles.phi_edit,'String');
config.light.rays = get(handles.rays_edit,'String');
config.light.beamdist = get(handles.beamdist_popupmenu,'Value');
config.light.beamradius = get(handles.beamradius_edit,'String');

config.material.n1 = get(handles.n1_edit,'String');
config.material.k1 = get(handles.k1_edit,'String');
config.material.n2 = get(handles.n2_edit,'String');
config.material.k2 = get(handles.k2_edit,'String');

% --- Executes on selection change in results_listbox.
function results_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to results_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns results_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from results_listbox
showsingleresults(handles)


% --- Executes during object creation, after setting all properties.
function results_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to results_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% check input parameters
function check = checkinput(handles)
check = 0;

% check surface input parameters
surface_check = 0;
if get(handles.mode1_togglebutton,'Value') % loaded surface
    contents = cellstr(get(handles.surf_listbox,'String'));
    if ~isempty(char(contents{:}))
        % step through every surface and check (to be added)
        surface_check = 1;
        contents_surfaces = get(handles.surf_listbox,'String');
        first_item = contents_surfaces{1};
        if strcmp(first_item(end-2:end-1),'1D')
            dim = 1;
        else
            dim = 2;
        end
        
    else
        errordlg('Error! No surface loaded!','modal');
        return
    end
elseif get(handles.mode2_togglebutton,'Value') % generated surface
    if ~isempty(get(handles.surfpts_edit,'String')) && ~isempty(get(handles.surflength_edit,'String')) && ...
            ~isempty(get(handles.rmsheight_edit,'String')) && ~isempty(get(handles.realisations_edit,'String')) && ...
            (~isempty(get(handles.clength_edit,'String')) || (~isempty(get(handles.clengthy_edit,'String')) && ~isempty(get(handles.clengthx_edit,'String'))))
        
        if get(handles.oned_togglebutton,'Value')
            dim = 1;
        else dim = 2;
        end
        
        % Number of realisations
        realisations = str2double(get(handles.realisations_edit,'String'));
        if ~(isnumeric(realisations) && (mod(realisations,round(realisations)) == 0) && ~isnan(realisations))
            errordlg('Error! Number of realisations must be a positive integer!','modal');
            return
        end
        
        % Number of surface points
        surfpts = str2double(get(handles.surfpts_edit,'String'));
        if (isnumeric(surfpts) && isreal(surfpts) && ~isnan(surfpts))
            if surfpts <= 0
                errordlg('Error! # of points must be a real and positive number!','modal');
                return
            end
        else
            errordlg('Error! # of points must be a real and positive number!','modal');
            return
        end
        
        % Surface length
        surflength = str2double(get(handles.surflength_edit,'String'));
        if (isnumeric(surflength) && isreal(surflength) && ~isnan(surflength))
            if surflength <= 0
                errordlg('Error! Length must be a real and positive number!','modal');
                return
            end
        else
            errordlg('Error! Length must be a real and positive number!','modal');
            return
        end
        
        % RMS height
        rmsheight = str2num(get(handles.rmsheight_edit,'String'));
        if (isnumeric(rmsheight) && isreal(rmsheight) && max(~isnan(rmsheight) == 1))
            if min(rmsheight) <= 0
                errordlg('Error! RMS height must be a real and positive number/vector!','modal');
                return
            else
                if length(rmsheight) > 1 % array input
                    if length(unique(rmsheight)) ~= length(rmsheight)
                        errordlg('Error! RMS height must be a vector of unique numbers!','modal');
                        return
                    end   
                end
            end
        else
            errordlg('Error! RMS height must be a real and positive number/vector!','modal');
            return
        end

        % Correlation length
        if get(handles.twod_togglebutton,'Value') && get(handles.noniso_checkbox,'Value') % non-isotropic surface
            clx = str2num(get(handles.clengthy_edit,'String'));
            cly = str2num(get(handles.clengthy_edit,'String'));
            if (isnumeric(clx) && isreal(clx) && max(~isnan(clx)) == 1) && ...
                    (isnumeric(cly) && isreal(cly) && max(~isnan(cly)) == 1)
                if min(clx) <= 0 || min(cly) <= 0
                    errordlg('Error! Correlation length must be a real and positive number/vector!','modal');
                    return
                else
                    if length(clx) > 1 || length(cly) > 1 % array input
                        if length(unique(clx)) ~= length(clx) || length(unique(cly)) ~= length(cly)
                            errordlg('Error! Correlation length must be a vector of unique numbers!','modal');
                            return
                        end
                    end
                end
            else
                errordlg('Error! Correlation length must be a real and positive number/vector!','modal');
                return
            end
            cl = 1;
        else % isotropic surface
            cl = str2num(get(handles.clength_edit,'String'));
            if (isnumeric(cl) && isreal(cl) && max(~isnan(cl)) == 1)
                if min(cl) <= 0
                    errordlg('Error! Correlation length must be a real and positive number/vector!','modal');
                    return
                else
                    if length(cl) > 1 % array input
                        if length(unique(cl)) ~= length(cl)
                            errordlg('Error! Correlation length must be a vector of unique numbers!','modal');
                            return
                        end
                    end
                end
            else
                errordlg('Error! Correlation length must be a real and positive number/vector!','modal');
                return
            end
            clx = 1; cly = 1;
        end
        
        % check length of vectors
        if (length(rmsheight) > 1 && length(cl) >  1) || (length(rmsheight) > 1 && length(clx) >  1) || (length(rmsheight) > 1 && length(cly) >  1)
            if length(rmsheight) ~= length(cl)
                errordlg('Error! RMS height and correlation length vectors must have the same number of elements!','modal');
                return
            end
        end

    else
        errordlg('Error! Not enough input parameters!','modal');
        return
    end
end

surface_check = 1;

% check light input parameters
light_check = 0;
if ~isempty(get(handles.theta_edit,'String')) && (~isempty(get(handles.phi_edit,'String')) || dim == 1) && ...
        ~isempty(get(handles.rays_edit,'String')) && ~isempty(get(handles.beamradius_edit,'String'))
    
    % Incident polar angle
    theta = str2num(get(handles.theta_edit,'String'));
    if (isnumeric(theta) && isreal(theta) && max(~isnan(theta)) == 1)
        if min(theta >= -90) == 0 || min(theta <= 90) == 0
            errordlg('Error! Theta must be a scalar or vector with real and positive numbers between -90 and 90 (degrees)!','modal');
            return
        else
            if length(theta) > 1 % array input
                if length(unique(theta)) ~= length(theta)
                    errordlg('Error! Theta must be a vector of unique numbers!','modal');
                    return
                end
            end
        end
    else
        errordlg('Error! Theta must be a real and positive number/vector!','modal');
        return
    end
    
    % Incident azimuth angle
    phi = str2num(get(handles.phi_edit,'String'));
    if dim == 2 % 2D surface
        if (isnumeric(phi) && isreal(phi) && max(~isnan(phi)) == 1)
            if min(phi >= 0) == 0 || min(phi <= 360) == 0
                errordlg('Error! Phi must be a scalar or vector with real and positive numbers between 0 and 360 (degrees)!','modal');
                return
            else
                if length(phi) > 1 % array input
                    if length(unique(phi)) ~= length(phi)
                        errordlg('Error! Phi must be a vector of unique numbers!','modal');
                        return
                    end
                end
            end
        else
            errordlg('Error! Phi must be a real and positive number/vector!','modal');
            return
        end
    end
    
    % Number of rays
    rays = str2double(get(handles.rays_edit,'String'));
    if (isnumeric(rays) && isreal(rays) && ~isnan(rays))
        if get(handles.mode2_togglebutton,'Value') % mode 2
            if rays <= 0
                errordlg('Error! # of rays must be a real and positive number!','modal');
                return
            elseif rays > surfpts
                errordlg('Error! # of rays must be less than or equal to # of surface points!','modal');
                return
            end
        else % mode 1
            if rays <= 0 || rays > 100
                errordlg('Error! # of rays is a percentage (e.g. a number between 0 and 100)!','modal');
                return
            end
        end
    else
        errordlg('Error! # of rays must be a real and positive number!','modal');
        return
    end
    
    % Beam radius
    beamradius = str2double(get(handles.beamradius_edit,'String'));
    if (isnumeric(beamradius) && isreal(beamradius) && ~isnan(beamradius))
        if get(handles.mode2_togglebutton,'Value') % mode 2
            if beamradius <= 0
                errordlg('Error! Beam radius must be a real and positive number!','modal');
                return
            elseif beamradius > surflength
                errordlg('Error! Beam radius must be smaller than surface length!','modal');
                return
            end
        else % mode 1
            if beamradius <= 0 || beamradius > 100
                errordlg('Error! Beam radius is a percentage (e.g. a number between 0 and 100)!','modal');
                return
            end
        end
    else
        errordlg('Error! Beam radius must be a real and positive number!','modal');
        return
    end
    
else
    errordlg('Error! Not enough input parameters!','modal');
    return
end

light_check = 1;

% check material data parameters
material_check = 0;
if ~isempty(get(handles.n1_edit,'String')) && ~isempty(get(handles.k1_edit,'String')) && ...
        ~isempty(get(handles.n2_edit,'String')) && ~isempty(get(handles.k2_edit,'String'))
    n1 = str2double(get(handles.n1_edit,'String'));
    k1 = str2double(get(handles.k1_edit,'String'));
    n2 = str2double(get(handles.n2_edit,'String'));
    k2 = str2double(get(handles.k2_edit,'String'));
    if (isnumeric(n1) && isreal(n1) && ~isnan(n1)) && ...
            (isnumeric(k1) && isreal(k1) && ~isnan(k1)) && ...
            (isnumeric(n2) && isreal(n2) && ~isnan(n2)) && ...
            (isnumeric(k2) && isreal(k2) && ~isnan(k2))
        if n1 > 0 && k1 >= 0 && n2 > 0 && k2 >= 0
            material_check = 1;
        end
    else
        errordlg('Error! All inputs must be real and positive numbers!','modal');
        return
    end
else
    errordlg('Error! Not enough input parameters!','modal');
    return
end

% everything okay
if surface_check && light_check && material_check
    check = 1;
end


%% version check
function check = versioncheck(configversion,handles)

if configversion >= handles.versionlimit
    check = 1;
else check = 0;
end


% --- Executes when selected object is changed in plotbuttons2D_panel.
function plotbuttons2D_panel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in plotbuttons2D_panel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

if eventdata.NewValue == handles.plotslope2D_togglebutton
    set(handles.plotvar2D_text,'String','Theta');
    set(handles.plotvar2D_listbox,'String',num2str(handles.Results.Thetas'));
    set(handles.plotvar2D_listbox,'Min',0); set(handles.plotvar2D_listbox,'Max',length(handles.Results.Thetas));
    set(handles.plotvar2D_listbox,'Value',1);
else
    set(handles.plotvar2D_text,'String','Slope');
    set(handles.plotvar2D_listbox,'String',num2str(handles.Results.Slopes'));
    set(handles.plotvar2D_listbox,'Min',0); set(handles.plotvar2D_listbox,'Max',length(handles.Results.Slopes));
    set(handles.plotvar2D_listbox,'Value',1);
end
showtotalresults(handles)


% --- Executes on selection change in plotvar3DA_listbox.
function plotvar3DA_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to plotvar3DA_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns plotvar3DA_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plotvar3DA_listbox
showtotalresults(handles);

% --- Executes during object creation, after setting all properties.
function plotvar3DA_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotvar3DA_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in plotvar3DB_listbox.
function plotvar3DB_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to plotvar3DB_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns plotvar3DB_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plotvar3DB_listbox
showtotalresults(handles);

% --- Executes during object creation, after setting all properties.
function plotvar3DB_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotvar3DB_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in plotvar2D_listbox.
function plotvar2D_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to plotvar2D_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns plotvar2D_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plotvar2D_listbox
showtotalresults(handles);

% --- Executes during object creation, after setting all properties.
function plotvar2D_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotvar2D_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in brdfslope_popupmenu.
function brdfslope_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to brdfslope_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns brdfslope_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from brdfslope_popupmenu
showtotalresults(handles);

% --- Executes during object creation, after setting all properties.
function brdfslope_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brdfslope_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in brdftheta_popupmenu.
function brdftheta_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to brdftheta_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns brdftheta_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from brdftheta_popupmenu
showtotalresults(handles);

% --- Executes during object creation, after setting all properties.
function brdftheta_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brdftheta_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in brdfphi_popupmenu.
function brdfphi_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to brdfphi_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns brdfphi_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from brdfphi_popupmenu
showtotalresults(handles);

% --- Executes during object creation, after setting all properties.
function brdfphi_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brdfphi_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in plotbuttons3D_panel.
function plotbuttons3D_panel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in plotbuttons3D_panel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if eventdata.NewValue == handles.plotslope3D_togglebutton
    set(handles.plotvar3DA_text,'String','Theta');  
    set(handles.plotvar3DA_listbox,'String',num2str(handles.Results.Thetas'));
    set(handles.plotvar3DA_listbox,'Min',0); set(handles.plotvar3DA_listbox,'Max',length(handles.Results.Thetas));
    set(handles.plotvar3DA_listbox,'Value',1);
    set(handles.plotvar3DB_text,'String','Phi');
    set(handles.plotvar3DB_listbox,'String',num2str(handles.Results.Phis'));
    set(handles.plotvar3DB_listbox,'Min',0); set(handles.plotvar3DB_listbox,'Max',1);
    set(handles.plotvar3DB_listbox,'Value',1);
elseif eventdata.NewValue == handles.plottheta3D_togglebutton
    if handles.Results.Mode == 1
        set(handles.plotvar3DA_text,'String','Phi');
        set(handles.plotvar3DA_listbox,'String',num2str(handles.Results.Phis'));
        set(handles.plotvar3DA_listbox,'Min',0); set(handles.plotvar3DA_listbox,'Max',length(handles.Results.Phis));
        set(handles.plotvar3DA_listbox,'Value',1);
        set(handles.plotvar3DB_text,'String','n/a');
        set(handles.plotvar3DB_listbox,'String','');
        set(handles.plotvar3DB_listbox,'Min',0); set(handles.plotvar3DB_listbox,'Max',1);
        set(handles.plotvar3DB_listbox,'Value',1);
        set(handles.plotvar3DB_listbox,'Enable','off');
    else
        set(handles.plotvar3DA_text,'String','Slope');
        set(handles.plotvar3DA_listbox,'String',num2str(handles.Results.Slopes'));
        set(handles.plotvar3DA_listbox,'Min',0); set(handles.plotvar3DA_listbox,'Max',length(handles.Results.Slopes));
        set(handles.plotvar3DA_listbox,'Value',1);
        set(handles.plotvar3DB_text,'String','Phi');
        set(handles.plotvar3DB_listbox,'String',num2str(handles.Results.Phis'));
        set(handles.plotvar3DB_listbox,'Min',0); set(handles.plotvar3DB_listbox,'Max',1);
        set(handles.plotvar3DB_listbox,'Value',1);
        set(handles.plotvar3DB_listbox,'Enable','on');
    end
else
    if handles.Results.Mode == 1
        set(handles.plotvar3DA_text,'String','Theta');
        set(handles.plotvar3DA_listbox,'String',num2str(handles.Results.Thetas'));
        set(handles.plotvar3DA_listbox,'Min',0); set(handles.plotvar3DA_listbox,'Max',length(handles.Results.Thetas));
        set(handles.plotvar3DA_listbox,'Value',1);
        set(handles.plotvar3DB_text,'String','n/a');
        set(handles.plotvar3DB_listbox,'String','');
        set(handles.plotvar3DB_listbox,'Min',0); set(handles.plotvar3DB_listbox,'Max',1);
        set(handles.plotvar3DB_listbox,'Value',1);
        set(handles.plotvar3DB_listbox,'Enable','off');
    else
        set(handles.plotvar3DA_text,'String','Slope');
        set(handles.plotvar3DA_listbox,'String',num2str(handles.Results.Slopes'));
        set(handles.plotvar3DA_listbox,'Min',0); set(handles.plotvar3DA_listbox,'Max',length(handles.Results.Slopes));
        set(handles.plotvar3DA_listbox,'Value',1);
        set(handles.plotvar3DB_text,'String','Theta');
        set(handles.plotvar3DB_listbox,'String',num2str(handles.Results.Thetas'));
        set(handles.plotvar3DB_listbox,'Min',0); set(handles.plotvar3DB_listbox,'Max',1);
        set(handles.plotvar3DB_listbox,'Value',1);
        set(handles.plotvar3DB_listbox,'Enable','on');
    end
end
showtotalresults(handles)



% --- Executes on selection change in phi2_popupmenu.
function phi2_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to phi2_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns phi2_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from phi2_popupmenu
showtotalresults(handles)

% --- Executes during object creation, after setting all properties.
function phi2_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to phi2_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in brdfplot_panel.
function brdfplot_panel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in brdfplot_panel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if get(handles.brdf2D_togglebutton,'Value')
    set(handles.phiplot_text,'Visible','on');
    set(handles.phi2_popupmenu,'Visible','on');
else
    set(handles.phiplot_text,'Visible','off');
    set(handles.phi2_popupmenu,'Visible','off');
end
showtotalresults(handles)


%% 1D Gaussian random rough surface with Gaussian autocovariance function
function [f,x] = rsgeng1D(N,rL,h,cl)
x = linspace(-rL/2,rL/2,N);
Z = h.*randn(1,N); % uncorrelated Gaussian random rough surface distribution with mean 0 and standard deviation h           
F = exp(-x.^2/(cl^2/2)); % Gaussian filter
f = sqrt(2/sqrt(pi))*sqrt(rL/N/cl)*ifft(fft(Z).*fft(F)); %correlation of surface using convolution (faltung), inverse Fourier transform and normalizing prefactors

%% 2D Gaussian random rough surface with Gaussian autocovariance function
function [f,x,y] = rsgeng2D(N,rL,h,clx,cly)
x = linspace(-rL/2,rL/2,N); y = linspace(-rL/2,rL/2,N);
[X,Y] = meshgrid(x,y); 
Z = h.*randn(N,N); % uncorrelated Gaussian random rough surface distribution with mean 0 and standard deviation h
% isotropic surface
if nargin == 4
    F = exp(-((X.^2+Y.^2)/(clx^2/2))); % Gaussian filter
    f = 2/sqrt(pi)*rL/N/clx*ifft2(fft2(Z).*fft2(F)); % correlation of surface including convolution (faltung), inverse Fourier transform and normalizing prefactors
% non-isotropic surface
elseif nargin == 5
    F = exp(-(X.^2/(clx^2/2)+Y.^2/(cly^2/2))); % Gaussian filter
    f = 2/sqrt(pi)*rL/N/sqrt(clx)/sqrt(cly)*ifft2(fft2(Z).*fft2(F)); % correlated surface generation including convolution (faltning) and inverse Fourier transform
end

%% 1D Gaussian random rough surface with exponential autocovariance function
function [f,x] = rsgene1D(N,rL,h,cl)
x = linspace(-rL/2,rL/2,N);
Z = h.*randn(1,N); % uncorrelated Gaussian random rough surface distribution with rms height h 
F = exp(-abs(x)/(cl/2)); % Gaussian filter
f = sqrt(2)*sqrt(rL/N/cl)*ifft(fft(Z).*fft(F)); % correlated surface generation including convolution (faltning) and inverse Fourier transform and normalizing prefactors

%% 2D Gaussian random rough surface with exponential autocovariance function
function [f,x,y] = rsgene2D(N,rL,h,clx,cly)
x = linspace(-rL/2,rL/2,N); y = linspace(-rL/2,rL/2,N);
[X,Y] = meshgrid(x,y); 
Z = h.*randn(N,N); % uncorrelated Gaussian random rough surface distribution with rms height h
% isotropic surface
if nargin == 4
    F = exp(-(abs(X)+abs(Y))/(clx/2)); % Gaussian filter
    f = 2*rL/N/clx*ifft2(fft2(Z).*fft2(F)); % correlation of surface including convolution (faltung), inverse Fourier transform and normalizing prefactors
% non-isotropic surface
elseif nargin == 5
    F = exp(-(abs(X)/(clx/2)+abs(Y)/(cly/2))); % Gaussian filter
    f = 2*rL/N/sqrt(clx*cly)*ifft2(fft2(Z).*fft2(F)); % correlation of surface including convolution (faltung), inverse Fourier transform and suitable prefactors
end
