function [e1,e2] = oc2dc(n,k)

% [e1,e2] = oc2dc(n,k) 
%
% converts the complex refractive index n+i*k to the complex dielectric 
% constant e1+i*e2.
%
% Input:  n  - refractive index
%         k  - extinction coefficient
%
% Output: e1 - real part of dielectric constant
%         e2 - imaginart part of dielectric constant
%
% Last updated: 2009-03-16
%

e1 = n^2 - k^2;

e2 = 2*n*k;
